angular.module('starter.controllers')

.controller('AddContactsCtrl', function($scope, $state, $timeout, $ionicLoading, $ionicHistory, $ionicPopup, TokkoServices, LocalServices, ContactoUtils) {
  var ctrl = this;
  
  ctrl.data = null;
  
  ctrl.clearData = function() {
    ctrl.data = {
      name:  "",
      email: "",
      phone: "",
      cellphone: "",
      comments: ""
    };
  }
  
  function agregarContactoSuccess(response) {
    if (response != null && response != undefined && response.success == true) {
      $ionicLoading.hide().then(function() {
        // console.log('contacto creado con id='+response.id);
        //LocalServices.actualizarListaContactos(true);
        LocalServices.contactoCreado(response.id);
        $state.go('tab.contacts-add-success');
        // $ionicLoading.show({
        //   template: 'Creando exitosamente'      
        // }).then(function() {
        //   $timeout(function() {
        //     $ionicLoading.hide().then(function() {
        //       if ($ionicHistory.backView() != null) {
        //         $ionicHistory.goBack();
        //       } else {
        //         $state.go('tab.contacts')
        //       }
        //     });
        //   }, 3000);
        // });
      });
    } else {            
      agregarContactoError({data:response});
    }
  }
  function agregarContactoError(response) {
    console.error(JSON.stringify(response));    
    $ionicLoading.hide().then(function() {
      var msg = 'El contacto no pudo ser creado';
      if (response != null && response.data != undefined && response.data.success == false && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });
    });
  }

  ctrl.contactoValido = false;
  ctrl.validarContacto = function() {
    result = ctrl.data != null && 
      ctrl.data.name != null && ctrl.data.name != undefined && ctrl.data.name.trim() != "" &&
      ((ctrl.data.email != null && ctrl.data.email != undefined && ctrl.data.email.trim() != "") || 
       (ctrl.data.phone != null && ctrl.data.phone != undefined && ctrl.data.phone.trim() != "") ||
       (ctrl.data.cellphone != null && ctrl.data.cellphone != undefined && ctrl.data.cellphone.trim() != ""));
    ctrl.contactoValido = result;
    //console.log(ctrl.contactoValido); 
    return result;
  }
  
  ctrl.agregarContacto = function() {
    if (ctrl.validarContacto()) {
      $ionicLoading.show({
          template: 'Creando contacto...'      
      }).then(function() {
        var key = window.localStorage.getItem("user-key");
        TokkoServices.agregarContacto({key:key}, ctrl.data, agregarContactoSuccess, agregarContactoError);
      });        
    }
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if ($ionicHistory.backView() == null) {
      $state.go('login');
      $ionicHistory.clearHistory();
    }
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
    LocalServices.contactoCreado(null);
    ctrl.clearData();
  }); 

});