// Ionic Starter App

angular.module('starter.controllers', []);
angular.module('starter.services', []);
angular.module('starter.utils', []);
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.utils', 'ngResource', 'ngCordova', 'ion-autocomplete'])

.directive('a', function () {
    return {
        restrict: 'E',
        link: function (scope, element, attrs) {
            if ( !attrs.href ){
                return;
            }
            var externalRe = new RegExp("^(http|https)://");
            var url = attrs.href;

            if(externalRe.test(url)) {
                element.on('click',function(e){
                    e.preventDefault();
                    if(attrs.ngClick){
                        scope.$eval(attrs.ngClick);
                    }
                    window.open(encodeURI(url), '_system');
                });
            }
        }
    };
})
.directive("preloadSrc", function() {
  return {
    link: function(scope, element, attrs) {
      var img, loadImage;
      img = null;
      // // console.log('loading: '+attrs.preloadId);
      loadImage = function() {
        //element[0].src = "pathToSpinner";
        // // console.log('loading: '+attrs.preloadSrc);

        img = new Image();
        img.src = attrs.preloadSrc;

        img.onload = function() {
          if (window.document.getElementById(attrs.preloadId) != undefined && window.document.getElementById(attrs.preloadId) != null)
            window.document.getElementById(attrs.preloadId).remove();
          element[0].src = attrs.preloadSrc;
        };
        img.onerror = function() {
          if (window.document.getElementById(attrs.preloadId) != undefined && window.document.getElementById(attrs.preloadId) != null)
            window.document.getElementById(attrs.preloadId).remove();
          element[0].src = 'img/no-image.svg'
        }
      };

      // scope.$watch((function() {
      //   return attrs.preloadSrc;
      // }), function(newVal, oldVal) {
      //   if (oldVal !== newVal) {
          loadImage();
        // }
      // });
    }
  };
})
.directive('ngEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if(event.which === 13) {
                scope.$apply(function (){
                    scope.$eval(attrs.ngEnter);
                });

                event.preventDefault();
            }
        });
    };
})
.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    window.addEventListener('native.keyboardshow', function () {
      var items = document.querySelectorAll('.hide-with-keyboard');
      for (var i=0; i<items.length; i++) {
        angular.element(items[i]).css('display', 'none');
      }      

      document.querySelector('div.tabs').style.display = 'none';
      angular.element(document.querySelector('ion-content.has-tabs')).css('bottom', 0);
    });
    window.addEventListener('native.keyboardhide', function () {
      var tabs = document.querySelectorAll('div.tabs');
      angular.element(tabs[0]).css('display', '');

      var items = document.querySelectorAll('.hide-with-keyboard');
      for (var i=0; i<items.length; i++) {
        angular.element(items[i]).css('display', '');
      }
    });

  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $resourceProvider) {
  
  $ionicConfigProvider.views.maxCache(0);
  $ionicConfigProvider.backButton.previousTitleText(false).text('');
  // $ionicConfigProvider.backButton.icon('my-back-button');
  $ionicConfigProvider.tabs.position('bottom');
  $resourceProvider.defaults.stripTrailingSlashes = false;
  
  $stateProvider
    .state('login', {
      url: '/login',
      templateUrl: 'templates/login.html',
      controller: 'LoginCtrl'
    })

    .state('tab', {
      url: '/tab',
      abstract: true,
      templateUrl: 'templates/tabs.html',
      controller: 'TabCtrl',
      controllerAs: 'ctrl'
    })

    .state('tab.dash', {
      url: '/dash?:page&:idContacto',
      views: {
        'tab-dash': {
          templateUrl: 'templates/tab-dash.html',
          controller: 'DashCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    .state('tab.dash-mail', {
      url: '/mail/:idContacto?mailContacto&adjuntos',
      views: {
        'tab-dash': {
          templateUrl: 'templates/tab-dash-mail.html',
          controller: 'MailCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    .state('tab.dash-send-mail-success', {
      url: '/mail/sended',
      views: {
        'tab-dash' :{
          templateUrl: 'templates/tab-dash-send-mail-success.html',
          controller: 'SendMailSuccessCtrl',
          controllerAs: 'ctrl'
        }
      }      
    })    
    .state('tab.dash-search', {
      url: '/search/:idContacto?nombreContacto&mailContacto&barrio&idBarrio&contacto&aplicarBusqueda',
      views: {
        'tab-dash': {
          templateUrl: 'templates/tab-dash-search.html',
          controller: 'SearchCtrl',
          controllerAs: 'ctrl'      
        }
      }
    })
    .state('tab.dash-searchDetail', {
      url: '/fichaPropiedad/:id?contacto',
      views: {
        'tab-dash': {
          templateUrl: 'templates/tab-news-propertyDetail.html',
          controller: 'FichaPropiedadCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    .state('tab.dash-searchFilter', {
      url: '/searchFilter',
      views: {
        'tab-dash': {
          templateUrl: 'templates/tab-news-searchFilter.html',
          controller: 'SearchFilterCtrl',
          controllerAs: 'ctrl'
        }
      }
    })

    .state('tab.news', {
      url: '/news?barrio&idBarrio&aplicarBusqueda',
      views: {
        'tab-news': {
          templateUrl: 'templates/tab-news.html',
          controller: 'NewsCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    .state('tab.news-detail', {
      url: '/fichaPropiedad/:id',
      views: {
        'tab-news': {
          templateUrl: 'templates/tab-news-propertyDetail.html',
          controller: 'FichaPropiedadCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    .state('tab.news-searchFilter', {
      url: '/searchFilter',
      views: {
        'tab-news': {
          templateUrl: 'templates/tab-news-searchFilter.html',
          controller: 'SearchFilterCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    
    .state('tab.contacts', {
      url: '/contacts?filtroBusqueda',
      views: {
        'tab-contacts': {
          templateUrl: 'templates/tab-contacts.html',
          controller: 'ContactsCtrl',
          controllerAs: 'ctrl'
        }
      }    
    })
    .state('tab.contacts-add', {
      url: '/addContact',
      views: {
        'tab-contacts' :{
          templateUrl: 'templates/tab-contacts-add.html',
          controller: 'AddContactsCtrl',
          controllerAs: 'ctrl'
        }
      }
    })
    .state('tab.contacts-add-success', {
      url: '/addContactSuccess',
      views: {
        'tab-contacts' :{
          templateUrl: 'templates/tab-contacts-add-success.html',
          controller: 'AddContactsSuccessCtrl',
          controllerAs: 'ctrl'
        }
      }      
    })
    .state('tab.contacts-detail', {
      url: '/detailContact?json',
      views: {
        'tab-contacts' :{
          templateUrl: 'templates/tab-contacts-detail.html',
          controller: 'DetailContactsCtrl',
          controllerAs: 'ctrl'
        }
      }
    });  

  $urlRouterProvider.otherwise('/login');
  
});
