angular.module('starter.utils')

.factory('ContactoUtils', function(DateUtils, PropiedadUtils, CurrencyUtils, LocalServices) {

  function processContacto(value) {
    
    if (value != null && value != undefined) {      
      value['_volatile_deleted_at_01'] = DateUtils.fromServiceToUI_01(value.deleted_at);
      value['_volatile_deleted_at_02'] = DateUtils.fromServiceToUI_02(value.deleted_at);

      if (value.name != null && value.name != undefined && value.name.trim() != "")
        value['_volatile_name'] = value.name.trim();
      else
        value['_volatile_name'] = "Sin nombre";
      
      //agent
      if (value['agent'] != undefined && value['agent'] != null && value['agent'].trim() != ""){
        value['_volatile_agent'] = value['agent'].trim();
      } else {        
        var usr = LocalServices.getUsername();
        //console.log('USR: '+usr);
        if (usr != null && usr != undefined)
          value['_volatile_agent'] = usr;
        else
          value['_volatile_agent'] = 'Sin agente'; //window.localStorage.getItem("user-name");        
      }

      //destacados
      if (value.starred != null && value.starred != undefined && value.starred.length > 0) {
        for (var pos = 0;pos<value.starred.length; pos++) {
          var destacado = value.starred[pos];
            
          // es un emprendimiento o una propiedad
          if (destacado.type.object == 'property') { //puede valer property o development
            destacado['_volatile_is_development'] = false;
          } else {
            destacado['_volatile_is_development'] = true;
          }
          
          if (destacado.operations != undefined && destacado.operations.length > 0) {
            if (destacado.operations.length == 1) {
              destacado['_volatile_operation'] = destacado.operations[0].type;
              if (destacado.operations[0].prices != undefined && destacado.operations[0].prices.length == 1) {
                destacado['_volatile_price'] = CurrencyUtils.formatCurrency(destacado.operations[0].prices[0].currency) + 
                  ' ' + CurrencyUtils.formatAmount(destacado.operations[0].prices[0].amount);              
              } else {
                destacado['_volatile_price'] = '';
              }
            } else {
              destacado['_volatile_operation'] = 'V/ALQ';
              destacado['_volatile_price'] = '';  
            }
          } else {
            //Actualmente por lo que veo en los datos las propiedades en construccion (development) no incluyen la propiedad 'operations'. 
            //Es correcto que asuma el mismo comportamiento que cuando el listado de operaciones es mayor a 1 y fije el texto en V/ALQ?
            destacado['_volatile_operation'] = '';
            destacado['_volatile_price'] = '';
          }                  
            
       
            
          var _volatile_type_with_barrio = '';
          if (destacado.type.name != undefined) {
            if (destacado.location != undefined) {
              _volatile_type_with_barrio = destacado.type.name + ' EN ' + destacado.location; 
            } else {
              _volatile_type_with_barrio = destacado.type.name
            }
          } else {
            if (destacado.location != undefined) {
              _volatile_type_with_barrio = 'EN ' + destacado.location; 
            }          
          }
          destacado['_volatile_type_with_barrio'] = _volatile_type_with_barrio;

          destacado['_volatile_date'] = DateUtils.fromServiceToUI_01(destacado.date);
          if (destacado.icon_attrs != undefined) {
            if (destacado.icon_attrs['length'] != undefined) {
              if (destacado.icon_attrs.length > 0) {
                for (var i=0; i<destacado.icon_attrs.length; i++) {
                  var newsAttr = PropiedadUtils.getPropNewsAttr(destacado.icon_attrs[i]);
                  if (newsAttr != undefined) {
                    destacado.icon_attrs[i]['_volatile_id'] = i;
                    destacado.icon_attrs[i]['_volatile_urlIcon'] = newsAttr.urlIcon;
                    destacado.icon_attrs[i]['_volatile_label'] = newsAttr.label;
                    var valor = destacado.icon_attrs[i][newsAttr.label];
                    if (valor != undefined && valor != null){
                      valor = valor.trim();
                      if (valor.match("m2$") != null) {
                        var n = parseInt(valor.substring(0, valor.length-2).trim());
                        if (n != undefined && n != null && !isNaN(n))
                          valor = n+" m2";
                      }
                    } else {
                      valor = '';
                    }
                    destacado.icon_attrs[i]['_volatile_value'] = valor;
                  }
                }
              }
              // alert('llega');
            } else {
              //no es un arreglo sino un objeto. necesario porque las construcciones (development) no son un listado
              var newsAttr = PropiedadUtils.getPropNewsAttr(destacado.icon_attrs);
              var newsValue = destacado.icon_attrs[newsAttr.label];
              destacado['icon_attrs'] = [{
                  _volatile_id: 0,
                  _volatile_urlIcon: newsAttr.urlIcon,
                  _volatile_label: newsAttr.label,
                  _volatile_value: newsValue
              }];
            }
          } else {
            destacado['icon_attrs'] = [];
          }
        }
      } else {
        value['starred'] = [];
      }
      
      //busquedas
      if (value.searches != null && value.searches != undefined && value.searches.length > 0) {
        for (var pos=0; pos<value.searches.length; pos++) {
          var busqueda = value.searches[pos];
          busqueda['_volatile_date'] = DateUtils.fromServiceToUI_01(busqueda.date);
        }        
      } else {
        value['searches'] = [];
      }
      // console.log('searchesL: '+value.searches.length);
      // console.log('searches: '+JSON.stringify(value.searches));
      
      value['_volatile_email'] = null;
      value['_volatile_telefono'] = null;

      //About
      var datos = [];
      if (value.phone != null && value.phone != undefined && value.phone != '') {
        datos.push({
          label: 'Teléfono',
          value: value.phone
        });
        if (value['_volatile_telefono'] == null)
          value['_volatile_telefono'] = value.phone;
      }
      if (value.other_phone != null && value.other_phone != undefined && value.other_phone != '') {
        datos.push({
          label: 'Teléfono secundario',
          value: value.other_phone
        });
        if (value['_volatile_telefono'] == null)
          value['_volatile_telefono'] = value.phone;
      }
      if (value.cellphone != null && value.cellphone != undefined && value.cellphone != '') {
        datos.push({
          label: 'Celular',
          value: value.cellphone
        });
        if (value['_volatile_telefono'] == null)
          value['_volatile_telefono'] = value.phone;
      }
      if (value.work_phone != null && value.work_phone != undefined && value.work_phone != '') {
        datos.push({
          label: 'Teléfono de trabajo',
          value: value.work_phone
        });
        if (value['_volatile_telefono'] == null)
          value['_volatile_telefono'] = value.phone;
      }

      if (value.email != null && value.email != undefined && value.email != '') {
        datos.push({
          label: 'eMail',
          value: value.email
        });
        if (value['_volatile_email'] == null)
          value['_volatile_email'] = value.email;
      }
      if (value.other_email != null && value.other_email != undefined && value.other_email != '') {
        datos.push({
          label: 'eMail secundario',
          value: value.other_email
        });
        if (value['_volatile_email'] == null)
          value['_volatile_email'] = value.email;
      }
      if (value.work_email != null && value.work_email != undefined && value.work_email != '') {
        datos.push({
          label: 'eMail de trabajo',
          value: value.work_email
        });
        if (value['_volatile_email'] == null)
          value['_volatile_email'] = value.email;
      }
      
      if (value.work_name != null && value.work_name != undefined && value.work_name != '') {
        datos.push({
          label: 'Empresa',
          value: value.work_name
        });
      }
      if (value.work_position != null && value.work_position != undefined && value.work_position != '') {
        datos.push({
          label: 'Cargo',
          value: value.work_position
        });
      }
      
      if (value.document_type != null && value.document_type != undefined && value.document_type != '') {
        datos.push({
          label: 'Tipo de documento',
          value: value.document_type
        });
      }
      if (value.document_number != null && value.document_number != undefined && value.document_number != '') {
        datos.push({
          label: 'Número de documento',
          value: value.document_number
        });
      }

      if (value.address != null && value.address != undefined && value.address != '') {
        datos.push({
          label: 'Dirección',
          value: value.address
        });
      }
      if (value.country != null && value.country != undefined && value.country != '') {
        datos.push({
          label: 'País',
          value: value.country
        });
      }
      if (value.language != null && value.language != undefined && value.language != '') {
        datos.push({
          label: 'Idioma',
          value: value.language
        });
      }

      value['datos'] = datos;
    }
    return value;
  }
    
  function processContactos(value, withoutReorder) {
    var result = [];
    var _withoutReorder = false;
    if (withoutReorder != undefined && withoutReorder != null)
      _withoutReorder = withoutReorder;
    if (value != null && value != undefined) {
      var lista = value;
      if (value['length'] == undefined && value['objects'] != undefined)
        lista = value.objects
      if (lista != null && lista != undefined && lista.length > 0) {
        if (_withoutReorder) {
          for (var i=0; i<lista.length; i++) {
            var item = processContacto(lista[i]);
            result.push(item);
          }

        } else {
          var lstPC = [];
          var lstTA = [];
          var lstE = [];
          var lstER = [];
          var lstX = [];
          
          for (var i=0; i<lista.length; i++) {
            var item = processContacto(lista[i]);
            if (item.lead_status.id == 16) //code == "PC"
              lstPC.push(item);
            else if (item.lead_status.id == 18) //code == "TA" 
              lstTA.push(item);
            else if (item.lead_status.id == 20) //code == "E"
              lstE.push(item);
            else if (item.lead_status.id == 19) //code == "ER"
              lstER.push(item);
            else 
              lstX.push(item);
          }
          
          result = lstPC.concat(lstTA).concat(lstE).concat(lstER).concat(lstX);
        }
      }
    }
    return result;
  }
  function extractMetainfo(value) {
    var result = null;
    if (value != null && value != undefined) {
      result = value.meta;
    }
    return result;
  }
  function extractPhones(value) {
    var datos = [];
    if (value != undefined && value != null) {
      if (value.phone != null && value.phone != undefined && value.phone != '') {
        datos.push({
          shortLabel: 'C',
          label: 'Teléfono',
          value: value.phone
        });
      }
      if (value.other_phone != null && value.other_phone != undefined && value.other_phone != '') {
        datos.push({
          shortLabel: 'C',
          label: 'Teléfono secundario',
          value: value.other_phone
        });
      }
      if (value.cellphone != null && value.cellphone != undefined && value.cellphone != '') {
        datos.push({
          shortLabel: 'M',
          label: 'Celular',
          value: value.cellphone
        });
      }
      if (value.work_phone != null && value.work_phone != undefined && value.work_phone != '') {
        datos.push({
          shortLabel: 'T',
          label: 'Teléfono de trabajo',
          value: value.work_phone
        });
      }
    }
    return datos;
  }

  return {
    metadata : extractMetainfo,
    process : processContacto,
    processList : processContactos,
    phones: extractPhones
  };
    
});