angular.module('starter.controllers')

.controller('ContactsCtrl', function($scope, $state, $stateParams, $timeout, $ionicLoading,  $ionicPlatform, $ionicPopup, $ionicHistory, $cordovaKeyboard, TokkoServices, LocalServices, ContactoUtils) {
  var ctrl = this;
  
  ctrl.cordovaKeyboardOk = LocalServices.cordovaKeyboardOk;

  ctrl.message = null;
  ctrl.messageIcon = false;

  ctrl.contactoABuscar = null;  
  ctrl.contactoABuscado = null;
  ctrl.metainfo = null;
  ctrl.contactos = null;

  // function recuperarFromLocal() {
  //   var result = false;
  //   if (LocalServices.contactosList() != null && LocalServices.contactosList() != undefined && LocalServices.contactosList().length > 0) {
      
  //     ctrl.contactoABuscar = null;  
  //     ctrl.contactoABuscado = null;

  //     ctrl.contactos = LocalServices.contactosList();
  //     ctrl.metainfo = LocalServices.contactosListMetadata();

  //     $state.go($state.current, {filtroBusqueda:undefined}, {reload: false, inherit: false, notify: false});
  //     ctrl.messageIcon = false;
  //     ctrl.message = null;

  //     result = true;
  //   }
  //   console.log("contactos presentes: "+result);
  //   return result;
  // }
  
  var contactosSuccess = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide().then(function() {
      ctrl.contactoABuscar = null;  
      ctrl.contactoABuscado = null;
      ctrl.metainfo = ContactoUtils.metadata(response);
      var listado = ContactoUtils.processList(response, true);
      if (ctrl.metainfo.offset == 0) 
        ctrl.contactos = listado;
      else
        ctrl.contactos = ctrl.contactos.concat(listado);

      // LocalServices.contactosListMetadata(ctrl.metainfo);
      // LocalServices.contactosList(ctrl.contactos);

      $state.go($state.current, {filtroBusqueda:undefined}, {reload: false, inherit: false, notify: false});
      if (ctrl.contactos.length == 0) {
        ctrl.messageIcon = true;
        ctrl.message = "Creá un nuevo contacto desde ";
      }
      else {
        ctrl.messageIcon = false;
        ctrl.message = null;
      }
    });
  }
  var contactosError = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide().then(function() {
      if (ctrl.metainfo == null || ctrl.metainfo == undefined || ctrl.metainfo.offset == 0) {
        ctrl.contactoABuscar = null;  
        ctrl.contactoABuscado = null;
        ctrl.metainfo = null;
        ctrl.contactos = [];
      } else {
        ctrl.metainfo.next = null;
      }
      var msg = 'No se pudo recuperar los contactos';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        ctrl.messageIcon = false;
        ctrl.message = "Error de conexión al recuperar los datos."
      });
      $state.go($state.current, {filtroBusqueda:undefined}, {reload: false, inherit: false, notify: false});
    });    
  }
  
  var contactosBusquedaSuccess = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.contactoABuscado = ctrl.contactoABuscar;
      ctrl.metainfo = null;
      ctrl.contactos = ContactoUtils.processList(response, true);
      $state.go($state.current, {filtroBusqueda:ctrl.contactoABuscar}, {reload: false, inherit: false, notify: false});
      if (ctrl.contactos.length == 0) {
        ctrl.messageIcon = false;
        ctrl.message = "No existen contactos con el nombre "+ctrl.contactoABuscar;
      }
      else {
        ctrl.messageIcon = false;
        ctrl.message = null;
      }
    });
  }
  var contactosBusquedaError = function(error) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.contactoABuscado = null;
      ctrl.metainfo = null;
      ctrl.contactos = [];
      $ionicPopup.alert({
        title: 'Error',
        template: 'No se pudo realizar la busqueda de los contactos'
      }).then(function() {
        ctrl.messageIcon = false;
        ctrl.message = "Error de conexión al recuperar los datos."
      });
      $state.go($state.current, {filtroBusqueda:ctrl.contactoABuscar}, {reload: false, inherit: false, notify: false});
    });
  }

  ctrl.cleanContacto = function() {
    // console.log('clean');
    ctrl.contactoABuscar = null;
    ctrl.buscar();
  }

  ctrl.primeroEnSuTipo = function(pos) {
    var result = false;
    if (pos >= 0 && pos < ctrl.contactos.length) {
      var item = ctrl.contactos[pos];
      var prev = pos>0?ctrl.contactos[pos-1]:null;
      if (prev == null)
        result = true;
      else if ((item.lead_status != undefined && prev.lead_status == undefined) ||
        (item.lead_status == undefined && prev.lead_status != undefined) || 
        (item.lead_status != undefined && prev.lead_status != undefined && item.lead_status.code != prev.lead_status.code))
        result = true;
    }
    return result;
  }
  
  ctrl.reloadData = function() {
    var key = window.localStorage.getItem("user-key");
    ctrl.metainfo = null;
    ctrl.contactos = [];
    // console.log('load data');
    if (ctrl.contactoABuscar == null) {
      TokkoServices.contactos({
        key:key, 
        limit:LocalServices.getCountItemsXPage(), 
        offset:0
      }, contactosSuccess, contactosError);      
    } else {
      TokkoServices.contactosBusqueda({key:key, expression:ctrl.contactoABuscar}, contactosBusquedaSuccess, contactosBusquedaError);
    }
  }

  ctrl.hasMoreData = function() {
    var result = false;
    if (ctrl.metainfo != null && ctrl.metainfo != undefined && ctrl.metainfo.next != null)
      result = true;
    return result;
  }
  ctrl.loadMoreData = function () {
    if (ctrl.metainfo != null && ctrl.metainfo != undefined && ctrl.metainfo.next != null) {
      // console.log('load more data');

      var key = window.localStorage.getItem("user-key");
      var page = ctrl.contactos.length;
      if (ctrl.contactoABuscar == null) {
        TokkoServices.contactos({
          key:key, 
          limit:LocalServices.getCountItemsXPage(), 
          offset:page
        }, contactosSuccess, contactosError);      
      } else {
        ctrl.metainfo.next = null;      
      }
    }
  }
  
  ctrl.buscar = function() {
    if (ctrl.cordovaKeyboardOk && $cordovaKeyboard != undefined)
      $cordovaKeyboard.close();
    if (ctrl.contactoABuscar != null) {
      ctrl.contactoABuscar = ctrl.contactoABuscar.trim();
      if (ctrl.contactoABuscar == '')
        ctrl.contactoABuscar = null;
    }

    if (LocalServices.actualizarListaContactos() || ((ctrl.contactoABuscar == null && ctrl.contactos == null) || ctrl.contactoABuscar != ctrl.contactoABuscado)) {
      LocalServices.actualizarListaContactos(false);      
      ctrl.contactos = null;
      $ionicLoading.show({
          template: 'Recuperando contactos...'      
      }).then(function() {
        ctrl.reloadData();
      });
    }
    
  }
  
  ctrl.addContact = function() {
    $state.go('tab.contacts-add');
  }
  
  ctrl.detail = function(index) {
    console.warn('contacot idx='+index);
    if (ctrl.contactos != null && ctrl.contactos != undefined && ctrl.contactos['length'] != undefined &&
      index >= 0 && index < ctrl.contactos.length) {
      var obj = ctrl.contactos[index];
      console.warn('contacot obj='+JSON.stringify(obj));
      if (obj != undefined && (obj['blocked'] == undefined || obj.blocked == false)) {
        if (obj.agent == undefined)        
          $state.transitionTo('tab.dash', {idContacto:obj.id, page:'About'});
        else
          $state.transitionTo('tab.contacts-detail', {json:JSON.stringify(obj)});
      }
    }
  }

  ctrl.nroTelefonico = null;
  ctrl.preCall = function(index) {
    if (ctrl.contactos != null && ctrl.contactos != undefined && ctrl.contactos['length'] != undefined &&
      index >= 0 && index < ctrl.contactos.length) {
      var obj = ctrl.contactos[index];

      var telefonos = ContactoUtils.phones(obj);
      if (telefonos.length == 1) {
        var nroTelefono = telefonos[0].value;
        if (window.plugins != undefined && window.plugins.CallNumber != undefined) {
          window.plugins.CallNumber.callNumber(function() {
              console.log('Call to number '+nroTelefono+' success');
            }, function() {
              console.log('Call to number '+nroTelefono+' error');
            }, nroTelefono, false);
        }
      } else if (telefonos.length > 0) {
        ctrl.nroTelefonico = null;
        var template = '';
        for (var i=0; i < telefonos.length; i++) {
          template += '<ion-radio ng-model="ctrl.nroTelefonico" ng-value="\''+telefonos[i].value+'\'">\
            <div style="font-size:x-small;">'+telefonos[i].label+'</div><div style="font-size:small;">'+telefonos[i].value+'</div></ion-radio>';  
        }  
      
        var popupCall = $ionicPopup.show({
            template: template,
            title: 'Llamar a '+obj.name,
            subTitle: 'Elija el número de teléfono',
            scope: $scope,
            buttons: [
              { text: 'Cancelar' },
              {
                text: '<b>Llamar</b>',
                type: 'button-positive',
                onTap: function(e) {
                  if (!ctrl.nroTelefonico) {
                    e.preventDefault();
                  } else {
                    return ctrl.nroTelefonico;
                  }
                }
              }
            ]
          }).then(function(nroTelefono) {
            if (nroTelefono != undefined) {
              if (window.plugins != undefined && window.plugins.CallNumber != undefined) {
                window.plugins.CallNumber.callNumber(function() {
                    console.log('Call to number '+nroTelefono+' success');
                  }, function() {
                    console.log('Call to number '+nroTelefono+' error');
                  }, nroTelefono, false);
              }              
            }
          });

      } else {
        $ionicPopup.alert({
          title: 'Error',
          template: 'El contacto no tiene ningún nro de teléfono cargado'
        });
      }
     }
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data){
    $ionicHistory.clearHistory();
    if (LocalServices.contactoCreado() != undefined && LocalServices.contactoCreado() != null && LocalServices.contactoCreado() >= 0) {
      var id = LocalServices.contactoCreado();
      LocalServices.contactoCreado(-1);    
      $state.transitionTo('tab.dash', {idContacto:id, page:'About'});
    } else {
      ctrl.contactoABuscar = $stateParams.filtroBusqueda;
      // console.log(ctrl.contactoABuscar);
      // if (ctrl.contactoABuscar != null && ctrl.contactoABuscar != undefined) {
        ctrl.buscar();
      // } else {
      //   if (!recuperarFromLocal()) {
      //     ctrl.buscar();
      //   }
      // }
    }
  });
   
});