angular.module('starter.utils')

.factory('CurrencyUtils', function() {
  
  function formatNumber(value, n, x, s, c) {
    var re = '\\d(?=(\\d{' + (x || 3) + '})+' + (n > 0 ? '\\D' : '$') + ')';
    var num = value.toFixed(Math.max(0, ~~n));

    return (c ? num.replace('.', c) : num).replace(new RegExp(re, 'g'), '$&' + (s || ','));
  }

  function formatCurrency(value) {
    var result = null;
    if (value != undefined && value != null) {
      var map = {
        'USD': 'U$S',
        'ARS': '$'
      }
      result = map[value] != undefined? map[value] : value;
    }
    return result;
  }

  function formatAmount(value) {
    var result = null;
    if (value != undefined && value != null) {
      result = formatNumber(value, 0, 3, '.', ',');
    }
    return result;
  }
  
  return {
    formatCurrency: formatCurrency,
    formatAmount: formatAmount
  };
});