angular.module('starter.controllers')

.controller('DashCtrl', function($scope, $state, $stateParams, $timeout, $ionicLoading, $ionicPopup, $ionicPlatform, $ionicHistory, TokkoServices, LocalServices, ContactoUtils, OportunidadUtils) {
  var ctrl = this;

  ctrl.message = null;
  ctrl.messageIcon = true;

  ctrl.metainfo = null;  
  ctrl.contactos = [];
  ctrl.subPage = 'Starred'; //Starred, Searches, About
  ctrl.currentContact = 0;
  
  ctrl.idContact = null;
      
  var contactosSuccess = function(value) {
    var contactoPendienteDeIndentificacion = ctrl.idContact != null;
    // console.log('ctrl.idContact='+ctrl.idContact);
    // console.log('contactoPendienteDeIndentificacion='+contactoPendienteDeIndentificacion);

      ctrl.metainfo = ContactoUtils.metadata(value);
      var listado = ContactoUtils.processList(value, true);
      // if (ctrl.metainfo.offset == 0) {
        ctrl.contactos = ctrl.contactos.concat(listado);
        // ctrl.contactos = listado;
        if (ctrl.currentContact > ctrl.contactos.length)
          ctrl.currentContact = 0;
        if (ctrl.idContact != null) {
          for (var i=0; i < ctrl.contactos.length; i++) {
            if (ctrl.contactos[i].id == ctrl.idContact) {
              ctrl.currentContact = i;
              contactoPendienteDeIndentificacion = false;
              break;
            }
          }
          if (!contactoPendienteDeIndentificacion)
            ctrl.idContact = null;
        }

        if (contactoPendienteDeIndentificacion && ctrl.hasMoreData()) {
          // console.log('DASH: contacto no encontrado! ['+ctrl.idContact+']');

          ctrl.loadMoreData();
        } else {
          $ionicLoading.hide().then(function() {

            if (contactoPendienteDeIndentificacion) {
            // if (!contactoPendienteDeIndentificacion) {
              // console.log('DASH: contacto encontrado! ('+ctrl.currentContact+')');
              // console.log(' json: '+JSON.stringify(ctrl.contactos[ctrl.currentContact]));
              // console.log(' ['+ctrl.contactos[ctrl.currentContact].id+']');
            // } else {
              ctrl.currentContact = 0;
              // console.log('DASH: contacto descartado! ('+ctrl.currentContact+')');
              // console.log(' ['+ctrl.contactos[ctrl.currentContact].id+']');
            }

            $state.go($state.current, {
                page:ctrl.subPage, 
                idContacto: ctrl.contactos.length>0? ctrl.contactos[ctrl.currentContact].id: (ctrl.idContact!=null?ctrl.idContact: undefined)}, 
                {location: 'replace', reload: false, inherit: false, notify: false});
            $timeout(function() {
              $scope.slider.update(false);
              $scope.slider.slideTo(ctrl.currentContact, 0, false);
            }, 100);

            if (ctrl.contactos.length == 0) {
              ctrl.message = "No hay oportunidades para mostrar, empezá cargando un contacto desde";
              ctrl.messageIcon = true;
            }
            else {
              ctrl.message = null;
              ctrl.messageIcon = false;
            }

          });
        }
      // } else {
      //   ctrl.contactos = ctrl.contactos.concat(listado);

        // if (ctrl.contactos.length == 0) {
        //   ctrl.message = "No hay oportunidades para mostrar, empeza cargando un contacto desde";
        //   ctrl.messageIcon = true;
        // }
        // else {
        //   ctrl.message = null;
        //   ctrl.messageIcon = false;
        // }
      // }

      // if (ctrl.contactos.length == 0) {
      //   ctrl.message = "No hay oportunidades para mostrar, empeza cargando un contacto desde";
      //   ctrl.messageIcon = true;
      // }
      // else {
      //   ctrl.message = null;
      //   ctrl.messageIcon = false;
      // }
    // });
  }
  var contactosError = function(error) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.metainfo = null;
      ctrl.contactos = [];
      ctrl.currentContact = 0;
      ctrl.idContact = null;
      $ionicPopup.alert({
        title: 'Error',
        template: 'No se pudieron recuperar los contactos'
      }).then(function() {
        ctrl.message = "Error de conexión al recuperar los datos"
        ctrl.messageIcon = false;
      });
      $state.go($state.current, {
        page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id
      }, {location: 'replace', reload: false, inherit: false, notify: false});
    });
  }

  var cerrarBusquedaSuccess = function(response) {
    $ionicLoading.hide().then(function() {
      if (response != undefined && response.success == true) {
        $ionicLoading.show({
            template: 'Actualizando contactos...'      
        }).then(function() {
          ctrl.reloadData();
        });  
      } else {
        cerrarBusquedaError({data:response});  
      }
    });
  }
  var cerrarBusquedaError = function(response) {
    $ionicLoading.hide().then(function() {
      var msg = "No se pudo cerrar la busqueda";
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });
    });
  }

  ctrl.reloadData = function() {
    var key = window.localStorage.getItem("user-key");
    TokkoServices.contactos({
      key:key, 
      limit:LocalServices.getCountItemsXPage(), 
      offset:0
    }, contactosSuccess, contactosError);
  }

  ctrl.hasMoreData = function() {
    var result = false;
    if (ctrl.metainfo != null && ctrl.metainfo != undefined && ctrl.metainfo.next != null)
      result = true;
    return result;
  }
  ctrl.loadMoreData = function () {
    if (ctrl.metainfo != null && ctrl.metainfo != undefined && ctrl.metainfo.next != null) {
      if (ctrl.idContact == null && ctrl.currentContact >= 0 && ctrl.contactos != undefined && ctrl.contactos != null && ctrl.currentContact < ctrl.contactos.length) {
        ctrl.idContact == ctrl.contactos[ctrl.currentContact];
      }
      // console.log('loadMoreData, idContact='+ctrl.idContact);

      var key = window.localStorage.getItem("user-key");
      var page = ctrl.contactos.length;
      TokkoServices.contactos({
        key:key, 
        limit:LocalServices.getCountItemsXPage(), 
        offset:page
      }, contactosSuccess, contactosError);      
    } else {
      console.warn('loadMoreData invoked without data!');
      $ionicLoading.hide();
    }
  }  
  
  ctrl.GoToStarred = function() {    
    ctrl.subPage = 'Starred';
    $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id}, {location: 'replace', reload: false, inherit: false, notify: false});
  };
  ctrl.GoToSearches = function() {
    ctrl.subPage = 'Searches';
    $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id}, {location: 'replace', reload: false, inherit: false, notify: false});
  };
  ctrl.GoToAbout = function() {
    ctrl.subPage = 'About';
    $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id}, {location: 'replace', reload: false, inherit: false, notify: false});
  };
  
  $scope.data ={};
  $scope.slideOptions = {
    loop: false,
    effect: 'slide',
    pagination: false,
    direction: 'horizontal',
    speed: 500
  }
  $scope.$on("$ionicSlides.sliderInitialized", function(event, data){
    $scope.slider = data.slider;
  });
  $scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
    // console.log('slideChangeEnd ('+$scope.slider.activeIndex+')');
    ctrl.currentContact = $scope.slider.activeIndex;
    $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id}, {location: 'replace', reload: false, inherit: false, notify: false});

    if (ctrl.currentContact == ctrl.contactos.length-1 && ctrl.hasMoreData()) {
      $timeout(function() {
        $ionicLoading.show({
            template: 'Actualizando contactos...'      
        }).then(function() {
          ctrl.loadMoreData();
        });      
      }, 500);
    }
  });  
  ctrl.GoToPrev = function() {
    if (ctrl.currentContact > 0) {
      ctrl.currentContact--;
      $scope.slider.slideTo(ctrl.currentContact, $scope.slideOptions.speed, false);
      $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id}, {location: 'replace', reload: false, inherit: false, notify: false});
    }
  };
  ctrl.GoToNext = function() {
    // if (ctrl.currentContact == ctrl.contactos.length-2 && ctrl.hasMoreData()) {
    //   $ionicLoading.show({
    //       template: 'Actualizando contactos...'      
    //   }).then(function() {
    //     ctrl.loadMoreData();
    //   });        
    // } else {
    if (ctrl.currentContact < ctrl.contactos.length-1) {
      ctrl.currentContact++;
      $scope.slider.slideTo(ctrl.currentContact, $scope.slideOptions.speed, false);
      $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id},  {location: 'replace', reload: false, inherit: false, notify: false});
    }
    if (ctrl.currentContact == ctrl.contactos.length-1 && ctrl.hasMoreData()) {
      $timeout(function() {
        $ionicLoading.show({
            template: 'Actualizando contactos...'      
        }).then(function() {
          ctrl.loadMoreData();
        });      
      }, 500);
    }
  };
  ctrl.GoToMail = function() {
    if (ctrl.contactos != null && ctrl.contactos != undefined && ctrl.currentContact >= 0 && ctrl.currentContact < ctrl.contactos.length) {
      var contacto = ctrl.contactos[ctrl.currentContact];
      if (contacto != null && contacto != undefined) {
        var idContacto = contacto.id;
        var mailContactoList = [];
        if (contacto.email != undefined && contacto.email != null && contacto.email.trim() != '') 
          mailContactoList.push(contacto.email.trim());
        if (contacto.other_email != undefined && contacto.other_email != null && contacto.other_email.trim() != '')
          mailContactoList.push(contacto.other_email.trim());        
        if (contacto.work_email != undefined && contacto.work_email != null && contacto.work_email.trim() != '')
          mailContactoList.push(contacto.work_email.trim());
        // mailContactoList.push('uno@mail');
        // mailContactoList.push('dos@mail')
        var mailContacto = null;
        if (mailContactoList.length > 0)
          mailContacto = mailContactoList.toString();

        var adjuntos = [];
        if (contacto.starred != undefined) {
          for (var i=0; i < contacto.starred.length; i++) {
            if (!contacto.starred[i]._volatile_is_development) {
              var item = {};
              item['id'] = contacto.starred[i].id;
              item['type_with_barrio'] = contacto.starred[i]._volatile_type_with_barrio;
              item['address'] = contacto.starred[i].address;
              item['operation'] = contacto.starred[i]._volatile_operation;
              item['price'] = contacto.starred[i]._volatile_price;    
              adjuntos.push(item);
            }
          }
        }

        if (mailContacto != undefined && mailContacto != null && mailContacto.trim() != '') {
          $state.transitionTo('tab.dash-mail', {idContacto:idContacto, mailContacto:mailContacto, adjuntos:JSON.stringify(adjuntos)});
        } else {
          $ionicPopup.alert({
            title: 'Error',
            template: 'El contacto no tiene mail cargado'
          });
        }
      }
    }
  }
  ctrl.GoToSearch = function() {
    if (ctrl.contactos != null && ctrl.contactos != undefined && ctrl.currentContact >= 0 && ctrl.currentContact < ctrl.contactos.length) {
      var contacto = ctrl.contactos[ctrl.currentContact];
      if (contacto != null && contacto != undefined) {
        var idContacto = contacto.id;
        var nombreContacto = contacto.name;
        var contacto = JSON.stringify(contacto);
        var mailContacto = contacto.email;
        if (mailContacto == undefined || mailContacto == null || mailContacto.trim() == '')
          mailContacto = contacto.other_email;        
        if (mailContacto == undefined || mailContacto == null || mailContacto.trim() == '')
          mailContacto = contacto.work_email;
        LocalServices.setSearchFilter(null);
        $state.transitionTo('tab.dash-search', {idContacto:idContacto, nombreContacto:nombreContacto, mailContacto:mailContacto, contacto:contacto});
      }
    }
  };

  ctrl.goPrevEnable = function() {
    var result = false;
    if (ctrl.contactos != undefined && ctrl.currentContact > 0 && ctrl.contactos.length > 0)
      result = true;
    return result;
  }
  ctrl.goNextEnable = function() {
    var result = false;
    if (ctrl.contactos != undefined) {
      if (ctrl.currentContact >= 0 && ctrl.contactos.length > 0 && ctrl.currentContact < ctrl.contactos.length-1)
        result = true;
      else if (ctrl.currentContact == ctrl.contactos.length-1 && ctrl.hasMoreData())
        result = true;
    }
    return result;
  }
  
  ctrl.checkAgenda = function() {
    var agendado = false;
    var options = new ContactFindOptions();
    options.filter = ctrl.contactos[ctrl.currentContact].name;
    options.multiple = false;
    fields = ["displayName"];
    navigator.contacts.find(fields, contactfindSuccess, contactfindError, options);
    
    function contactfindSuccess(contacts) {
      
      for (var i = 0; i < contacts.length; i++) {
         alert("Display Name = " + contacts[i].displayName);
         adendado = true;
      }
     //   console.log("agendad: "+agendado);
      return agendado;
    }
	
  }
  
  ctrl.cerrarBusqueda = function(idContacto, idBusqueda) {
    $ionicPopup.confirm({
      title: 'Cerrar Búsqueda',
      template: 'Borrar la búsqueda?'
    }).then(function(res) {
      if(res) {
        $ionicLoading.show({
            template: 'Cerrando búsqueda...'      
        }).then(function() {
          var key = window.localStorage.getItem("user-key");
          var contactId = idContacto;
          var jsonData = {key:key, contactId: idContacto, searchId:idBusqueda};
          //// console.log(JSON.stringify(jsonData));
          TokkoServices.cerrarBusqueda(jsonData, cerrarBusquedaSuccess, cerrarBusquedaError)
        });
      }
    });
  }

  modalView = {};
  modalView.show = function () {
    var modalViewId = 'statusCodeWindow';
    var modalContainer = $('#modalView');
    if (modalContainer != undefined && modalContainer[0] != undefined) {      
      var modalView = $('#'+modalViewId);
      if (modalView != undefined && modalView[0] != undefined) {
        // console.log('show estados!');
        var functUpdatePosition = function() {
          var act = ctrl.contactos[ctrl.currentContact];
          var tagRef = $('#btnStatusCode-'+act.id);
          if (tagRef != undefined && tagRef[0] != undefined) {
            var left = tagRef.offset().left - 2;
            var top = tagRef.offset().top - 2;
            var width = tagRef.outerWidth()+4;
            // var height = tagRef.outerHeight();
            modalView.css('left', left);
            modalView.css('top', top);    
            modalView.css('max-width', width);
            // modalView.css('max-height', height);
          } else {
            modalView.css('left', '');
            modalView.css('top', '');
            modalView.css('max-width', '');
            // modalView.css('max-height', '');
          }
        }
        $(window).resize(functUpdatePosition);
        functUpdatePosition();
        // $ionicPlatform.onHardwareBackButton(ctrl.hide);
        modalView.css('display', '');
      }
      modalContainer.css('display', 'block');
    }
  }
  modalView.hide = function () {
    var modalViewId = 'statusCodeWindow';
    var modalContainer = $('#modalView');    
    // $ionicPlatform.offHardwareBackButton(ctrl.hide);
    if (modalContainer != undefined && modalContainer[0] != undefined) {
      modalContainer.css('display', 'none');

      var modalView = $('#'+modalViewId);
      if (modalView != undefined && modalView[0] != undefined) {
        modalView.css('display', 'none');
      }
    }    
  }

  ctrl.oportunidadesMeta = null;
  ctrl.oportunidades = [];
  var oportunidadesSuccess = function(response) {
    if (response != undefined && response['objects'] != undefined) {
      $ionicLoading.hide().then(function() {
        // console.log('estados response!');
        ctrl.oportunidadesMeta = OportunidadUtils.processList(response);
        var lista = OportunidadUtils.processList(response);
        //se deshabilita el reordenamiendo de los estados para que coincida el primero con el actual
        // if (ctrl.currentContact >= 0 && ctrl.currentContact < ctrl.contactos.length) {
        //   for (var i=0; i < lista.length; i++) {
        //     if (lista[i].id == ctrl.contactos[ctrl.currentContact].lead_status.id) {
        //       var it = lista.splice(i, 1);
        //       lista = it.concat(lista);
        //       break
        //     }
        //   }
        // }
        ctrl.oportunidades = lista;
        modalView.show();
      });
    } else {
      oportunidadesError({data:response});
    }
  }
  var oportunidadesError = function(response) {
    $ionicLoading.hide().then(function() {
      ctrl.oportunidadesMeta = null;
      ctrl.oportunidades = [];
      var msg = "No se pudo recuperar el listado de estados";
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });
    });
  }

  ctrl.setStatus = function(indexStatus, idStatus) {
    if (ctrl.currentContact >= 0 && ctrl.currentContact < ctrl.contactos.length) {
      var act = ctrl.contactos[ctrl.currentContact];
      if (act.lead_status.id != idStatus) {
        $ionicLoading.show({
            template: 'Cambiando estado...'      
        }).then(function() {
          var key = window.localStorage.getItem("user-key");
          TokkoServices.cambiarOportunidad({key:key, contactId:act.id}, {id:idStatus}, 
            function(response) {
              if (response != undefined && response['success'] == true) {
                // console.log(JSON.stringify(response));
                $ionicLoading.hide().then(function() {
                  var nuevoEstado = ctrl.oportunidades[indexStatus];
                  act.lead_status.id = nuevoEstado.id;
                  act.lead_status.code = nuevoEstado._volatile_code;
                  act.lead_status.name = nuevoEstado.name;
                  act.lead_status.color = nuevoEstado.color;

                  if (response.is_closed == true) {
                    if (ctrl.currentContact < ctrl.contactos.length-1) {
                      ctrl.currentContact++;
                      $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id},  {reload: false, inherit: false, notify: false});
                    } else {
                      ctrl.currentContact = 0;
                      $state.go($state.current, {page:ctrl.subPage, idContacto: ctrl.contactos[ctrl.currentContact].id},  {reload: false, inherit: false, notify: false});
                    }
                    ctrl.reloadData();
                  }
                });

              } else {
                $ionicLoading.hide().then(function() {
                  var msg = "No se pudo cambiar el estado";
                  if (response['reason'] != undefined)
                    msg = response.reason;
                  $ionicPopup.alert({
                    title: 'Error',
                    template: msg
                  });
                });            
              }

            }, function(response) {
              $ionicLoading.hide().then(function() {
                var msg = "No se pudo cambiar el estado";
                if (response != undefined && response.data != undefined && response.data.reason != undefined)
                  msg = response.data.reason;
                $ionicPopup.alert({
                  title: 'Error',
                  template: msg
                });
              });            
            });
        });  
      }
    }
  }

  ctrl.changeStatus = function() {
    $ionicLoading.show({
        template: 'Recuperando estados...'      
    }).then(function() {
      var key = window.localStorage.getItem("user-key");
      TokkoServices.oportunidades({key:key}, oportunidadesSuccess, oportunidadesError);
    });  
  }
  ctrl.statusCodeCancel = function() {
    var itemAdjunto = $('#statusCodeWindow');
    var removeItem = function(event) {
      $("body").off('animationend webkitAnimationEnd', removeItem);
      modalView.hide();
      itemAdjunto.removeClass('itemMailAdjunto-remove');
    }
    $("body").on('animationend webkitAnimationEnd', removeItem);

    itemAdjunto.addClass('itemMailAdjunto-remove');
  }

  ctrl.nroTelefonico = null;
  ctrl.Call = function() {
    if (ctrl.currentContact >= 0 && ctrl.currentContact < ctrl.contactos.length) {
      var cc = ctrl.contactos[ctrl.currentContact];
      var telefonos = ContactoUtils.phones(cc);
      if (telefonos.length == 1) {
        var nroTelefono = telefonos[0].value;
         
        if (window.plugins != undefined && window.plugins.CallNumber != undefined) {
          window.plugins.CallNumber.callNumber(function() {
              console.log('Call to number '+nroTelefono+' success');
            }, function() {
              console.log('Call to number '+nroTelefono+' error');
            }, nroTelefono, false);
        }
      } else if (telefonos.length > 0) {
        ctrl.nroTelefonico = null;
        var template = '';
        for (var i=0; i < telefonos.length; i++) {
          template += '<ion-radio ng-model="ctrl.nroTelefonico" ng-value="\''+telefonos[i].value+'\'">\
            <div style="font-size:x-small;">'+telefonos[i].label+'</div><div style="font-size:small;">'+telefonos[i].value+'</div></ion-radio>';  
        }  
      
        var popupCall = $ionicPopup.show({
            template: template,
            title: 'Llamar a '+cc.name,
            subTitle: 'Elija el número de teléfono',
            scope: $scope,
            buttons: [
              { text: 'Cancelar' },
              {
                text: '<b>Llamar</b>',
                type: 'button-positive',
                onTap: function(e) {
                  if (!ctrl.nroTelefonico) {
                    e.preventDefault();
                  } else {
                    return ctrl.nroTelefonico;
                  }
                }
              }
            ]
          }).then(function(nroTelefono) {
            if (nroTelefono != undefined) {
              if (window.plugins != undefined && window.plugins.CallNumber != undefined) {
                window.plugins.CallNumber.callNumber(function() {
                    console.log('Call to number '+nroTelefono+' success');
                  }, function() {
                    console.log('Call to number '+nroTelefono+' error');
                  }, nroTelefono, false);
              }              
            }
          });

      } else {
        $ionicPopup.alert({
          title: 'Error',
          template: 'El contacto no tiene ningún nro de teléfono cargado'
        });        
      }
    }
  }

  ctrl.showPropiedadDestacada = function(index, idProp) {
    if (ctrl.currentContact >= 0 && ctrl.currentContact < ctrl.contactos.length) {
      var contacto = ctrl.contactos[ctrl.currentContact];
      if (index >= 0 && index < contacto.starred.length) {
        var propDestacada = contacto.starred[index];
        if (propDestacada._volatile_is_development == false) {
          var contactoJson = JSON.stringify(contacto);
          $state.transitionTo('tab.dash-searchDetail', {id:idProp, contacto:contactoJson});
        } else {
          console.log("no se muestra del detalle de la propiedad porque es un emprendimiento");
        }
      }
    }
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if (window.localStorage.getItem("user-name") == undefined ||
      window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
  }); 

$scope.checkContact = function() {
    $scope.showAgendar = true;
    var options = new ContactFindOptions();
    options.filter = ctrl.contactos[ctrl.currentContact].name;
    options.multiple = false;
    fields = ["displayName"];
    navigator.contacts.find(fields, contactfindSuccess, contactfindError, options);
    
    function contactfindSuccess(contacts) {
      
      for (var i = 0; i < contacts.length; i++) {
         alert("Display Name = " + contacts[i].displayName);
      }
      $scope.showAgendar = false;
    }
	
    function contactfindError(message) {
      alert('Failed because: ' + message);
    }
}

$scope.compartirDash = function(index, cover, public_url) {
    
    if (ionic.Platform.device().platform == 'iOS') {
        window.plugins.socialsharing.shareViaWhatsApp( ctrl.contactos[ctrl.currentContact].starred[index].fake_address , null, ctrl.contactos[ctrl.currentContact].starred[index].public_url );
    }else{         
        if ( cover == 'img/no-image.svg') {
            cover = null;
        }
        window.plugins.socialsharing.shareViaWhatsApp( ctrl.contactos[ctrl.currentContact].starred[index].fake_address, cover, '\n'+ctrl.contactos[ctrl.currentContact].starred[index].public_url );
    }
}   

$scope.agendar = function() {
      
    var agenContacto = ctrl.contactos[ctrl.currentContact];
    var newContact = navigator.contacts.create();
    
    if (ionic.Platform.device().platform == 'iOS') {
        var name = new ContactName();
        name.givenName = agenContacto.name;
        newContact.name = name;
    }else{
        if ( agenContacto.name ) {
            newContact.displayName = agenContacto.name;    
        }
    }
    
    var contactEmails = [];
    
    if (agenContacto.email != undefined && agenContacto.email != null && agenContacto.email.trim() != '') {
        contactEmails[0] = new ContactField('email', agenContacto.email.trim(), true);
    }
    if (agenContacto.work_email != undefined && agenContacto.work_email != null && agenContacto.work_email.trim() != '') {
        contactEmails[1] = new ContactField('work', agenContacto.work_email.trim(), false);
    }
    if (agenContacto.other_email != undefined && agenContacto.other_email != null && agenContacto.other_email.trim() != '') {
        contactEmails[2] = new ContactField('other', agenContacto.other_email.trim(), false);        
    }
    
    
    if (contactEmails.length > 0) {
        newContact.emails = contactEmails;
    }
    
    var phoneNumbers = [];

    if ( ContactoUtils.phones(ctrl.contactos[ctrl.currentContact]).length > 0 ) {
        phoneNumbers[0] = new ContactField('work', ContactoUtils.phones(ctrl.contactos[ctrl.currentContact])[0].value.toString(), false);
    
        if ( ContactoUtils.phones(ctrl.contactos[ctrl.currentContact]).length > 1 ) {
            phoneNumbers[1] = new ContactField('mobile', ContactoUtils.phones(ctrl.contactos[ctrl.currentContact])[1].value.toString(), true);
        }
        newContact.phoneNumbers = phoneNumbers;
    }
    
    newContact.save(contactSuccess, contactError);
    
   function contactSuccess() {
     
       if (newContact.name) {
           var msg = "El contacto fue agregado a tu teléfono";
       }else{
           var msg = "El contacto <b>"+newContact.displayName+"</b> fue agregado a tu teléfono";
       }
        
      $ionicPopup.alert({
        title: 'Contacto Agendado',
        template: msg
        
      });
   }
	
   function contactError(message) {
      $ionicPopup.alert({
        
        template: 'No se pudo agendar el contacto. Intente nuevamente.'
      });
   }
}    
    
  $scope.$on("$ionicView.enter", function(event, data){
    ctrl.metainfo = null;  
    ctrl.contactos = [];
    ctrl.currentContact = 0;
    ctrl.idContact = null;

    if ($stateParams.page != undefined) {
      if ($stateParams.page == 'Starred' || $stateParams.page == 'Searches' || $stateParams.page == 'About')
        ctrl.subPage = $stateParams.page;
      else
        ctrl.subPage = 'Starred';
    }
    if ($stateParams.idContacto != undefined) {
      ctrl.idContact = $stateParams.idContacto;
    } else {
      ctrl.idContact = null;
    }
    $ionicHistory.clearHistory();
    $ionicLoading.show({
        template: 'Recuperando contactos...'      
    }).then(function() {
      ctrl.reloadData();
    });
  }); 
});