angular.module('starter.controllers')

.controller('FichaPropiedadCtrl', function($scope, $state, $stateParams, $timeout, $ionicLoading, $ionicHistory, $ionicPopup, $ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, TokkoServices, PropiedadUtils, ContactoUtils, LocalServices) {
  
  var ctrl = this;

  ctrl.contacto = null;  
  ctrl.propId = null;
  ctrl.prop = null;
  
  ctrl.verMapaEnable = true;
  ctrl.verMapaVisible = false;

  ctrl.informacionInternaEnable = true;
  ctrl.informacionInternaVisible = false;

  ctrl.contactosPendiententes = [];
  ctrl.contactos = null;
   
    
  var contactosSuccess = function(response) {
    if (ctrl.contactos == null) 
      ctrl.contactos = [];
    var cto = ContactoUtils.process(response)
    var tels = ContactoUtils.phones(response)
    cto['_volatile_telefonos'] = tels;
    ctrl.contactos.push(cto);
    if (ctrl.contactosPendiententes.length > 0) {
      var curr = ctrl.contactosPendiententes.splice(0, 1)[0];
      var key = window.localStorage.getItem("user-key");
      TokkoServices.contactoById({key:key, contactId:curr.id}, contactosSuccess, contactosError);
    } else {
      $ionicLoading.hide().then(function() {
        ctrl.informacionInternaVisible = !ctrl.informacionInternaVisible;
        $ionicScrollDelegate.scrollBottom(true);
      });
    }
      
  } 
  var contactosError = function(response) {
    $ionicLoading.hide().then(function() {
      // console.log('error de contactos.');

      for (var i=0; i < ctrl.contactosPendiententes.length; i++) {
        ctrl.contactos.push({
          id: ctrl.contactosPendiententes[i].id,
          name: ctrl.contactosPendiententes[i].name,
          blocked: false
        })
      }

      var msg = 'Error recuperando los detalles de los propietarios';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        ctrl.informacionInternaVisible = !ctrl.informacionInternaVisible;
        $ionicScrollDelegate.scrollBottom(true);        
      })
    });    
  }
  
  ctrl.toggleVerMapa = function() {
    ctrl.verMapaVisible = !ctrl.verMapaVisible;
    if (ctrl.verMapaVisible)
      ctrl.updateMapa();
  }
  ctrl.toggleInformacionInterna = function() {
    if (ctrl.contactos == null && !ctrl.informacionInternaVisible) {
      if (ctrl.prop.owners.length == 0) {
        ctrl.contactos = [];
        ctrl.informacionInternaVisible = !ctrl.informacionInternaVisible;
      } else {
        $ionicLoading.show({
          template: 'Recuperando info de los contactos...'
        }).then(function() {
          // ctrl.contactosPendiententes = [{id:1976440, name:'Agustin'}, {id:2007094, name:'Facu'}]; 
          ctrl.contactosPendiententes = ctrl.prop.owners.slice();
          var curr = ctrl.contactosPendiententes.splice(0, 1)[0];
          var key = window.localStorage.getItem("user-key");
          TokkoServices.contactoById({key:key, contactId:curr.id}, contactosSuccess, contactosError);
        });
      }
    } else {
      ctrl.informacionInternaVisible = !ctrl.informacionInternaVisible;
      $ionicScrollDelegate.scrollBottom(true);
    }
  }
  
  function reqSuccess(data) {
    $ionicLoading.hide().then(function() {
      ctrl.prop = PropiedadUtils.process(data);
      
      if (ctrl.contacto != null) {    
          if (ctrl.contacto.starred.length > 0) {
              for (var i=0; i< ctrl.contacto.starred.length; i++) {
                if(JSON.stringify(ctrl.contacto.starred[i].id) == ctrl.propId) {
                    ctrl.prop._volatile_is_starred = true;
                }
              }     
          }
      }
        
      if (ctrl.prop.geo_lat != null && ctrl.prop.geo_lat != undefined &&
        ctrl.prop.geo_long != null && ctrl.prop.geo_long != undefined) {
        ctrl.verMapaEnable = true;    
      } else {
        ctrl.verMapaEnable = false;
      }
    });        
      
  }
    

ctrl.sendmail = function() {
    
    var idContacto = ctrl.contacto.id;
    var mailContactoList = [];
    if (ctrl.contacto.email != undefined && ctrl.contacto.email != null && ctrl.contacto.email.trim() != '') 
      mailContactoList.push(ctrl.contacto.email.trim());
    if (ctrl.contacto.other_email != undefined && ctrl.contacto.other_email != null && ctrl.contacto.other_email.trim() != '')
      mailContactoList.push(ctrl.contacto.other_email.trim());        
    if (ctrl.contacto.work_email != undefined && ctrl.contacto.work_email != null && ctrl.contacto.work_email.trim() != '')
      mailContactoList.push(ctrl.contacto.work_email.trim());
    // mailContactoList.push('uno@mail');
    // mailContactoList.push('dos@mail')
    var mailContacto = null;
    if (mailContactoList.length > 0)
      mailContacto = mailContactoList.toString();

    var adjuntos = [];

      var item = {};
      item['id'] = ctrl.prop.id;
      item['type_with_barrio'] = ctrl.prop._volatile_type_with_barrio;
      item['address'] = ctrl.prop.address;
      item['operation'] = ctrl.prop._volatile_operation;
      item['price'] = ctrl.prop._volatile_price;    
      adjuntos.push(item);


    if (mailContacto != undefined && mailContacto != null && mailContacto.trim() != '') {
      $state.transitionTo('tab.dash-mail', {idContacto:idContacto, mailContacto:mailContacto, adjuntos:JSON.stringify(adjuntos)});
    } else {
      $ionicPopup.alert({
        title: 'Error',
        template: 'El contacto no tiene mail cargado'
      });
    }
  }
    
    
    
    
    
$scope.compartir = function() {
      
    if (ionic.Platform.device().platform == 'iOS') {
        window.plugins.socialsharing.shareViaWhatsApp( ctrl.prop.fake_address , null, ctrl.prop.public_url );
    }else{
        var imagews = null;
        for (var i=0; i < ctrl.prop.photos.length; i++) {
            if (ctrl.prop.photos[i].is_front_cover){
                imagews = ctrl.prop.photos[i].image;
            }
        }
        if ( imagews == 'img/no-image.svg') {
            imagews = null;
        }

     // window.plugins.socialsharing.canShareVia('whatsapp', ctrl.prop.address, ctrl.prop.photos[0].image, ctrl.prop.public_url, function(e){alert(e)}, function(e){alert(e)});
        window.plugins.socialsharing.shareViaWhatsApp( ctrl.prop.fake_address, imagews,'\n'+ctrl.prop.public_url );
        
    }
}        

  
  ctrl.unstarfor = function() {
      
    $ionicLoading.show({
      template: 'Quitando destacado...'
    }).then(function() {
      var key = window.localStorage.getItem("user-key");
      TokkoServices.borrarDestacado({key:key, contactId: ctrl.contacto.id, objId: ctrl.propId}, {type:'property'}, function(response) {
        //success
        $ionicLoading.hide().then(function() {              
          if (response != undefined && response.success != undefined && response.success == true) {
            ctrl.prop._volatile_is_starred = false;

            for (var i=0; i < ctrl.contacto.starred.length; i++) {
              if (ctrl.propId == ctrl.contacto.starred[i].id) {
                ctrl.contacto.starred.splice(i, 1);
                break;
              }
            }
            $state.go($state.current, {
              idContacto:ctrl.idContacto, 
              nombreContacto:ctrl.nombreContacto, 
              mailContacto:ctrl.mailContacto, 
              barrio:ctrl.barrio, 
              idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined, 
              contacto:ctrl.contacto!=null?JSON.stringify(ctrl.contacto):undefined,
              aplicarBusqueda:ctrl.aplicarBusqueda
            }, {location: 'replace', reload: false, inherit: false, notify: false});
          } else {
            var msg = 'No se pudo quitar el destacado';
            if (response != undefined && response.reason != undefined)
              msg = response.reason;
            $ionicPopup.alert({
              title: 'Error',
              template: msg
            });      
          }
        });
      }, function (response) {
        //error
        $ionicLoading.hide().then(function() {
          var msg = 'No se pudo quitar el destacado';
          if (response != undefined && response.reason != undefined)
            msg = response.reason;
          $ionicPopup.alert({
            title: 'Error',
            template: msg
          });
        });
      });
    });
  }
  
  ctrl.starfor = function() {
    $ionicLoading.show({
      template: 'Destacando...'
    }).then(function() { 
     var key = window.localStorage.getItem("user-key");
      TokkoServices.crearDestacado({key:key, contactId: ctrl.contacto.id}, {id:ctrl.propId, type:'property'}, function(response) {
        //success
        $ionicLoading.hide().then(function() {
          if (response != undefined && response.success != undefined && response.success == true) {
            ctrl.prop._volatile_is_starred = true;
            ctrl.contacto.starred.push({
              id: ctrl.propId,
              type: {'object': 'property'}
            });
              
            $state.go($state.current, {
              idContacto:ctrl.idContacto, 
              nombreContacto:ctrl.nombreContacto, 
              mailContacto:ctrl.mailContacto,
              barrio:ctrl.barrio, 
              idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined, 
              contacto:ctrl.contacto!=null?JSON.stringify(ctrl.contacto):undefined,
              aplicarBusqueda:ctrl.aplicarBusqueda
            }, {location: 'replace', reload: false, inherit: false, notify: false});  
          } else {
            var msg = 'No se pudo destacar la propiedad';
            if (response != undefined && response.reason != undefined)
              msg = response.reason;
            $ionicPopup.alert({
              title: 'Error',
              template: msg
            });      
          }
        }); 
     }, function (response) {
        //error 
        $ionicLoading.hide().then(function() { 
          var msg = 'No se pudo destacar la propiedad'; 
          if (response != undefined && response.reason != undefined)
            msg = response.reason; 
          $ionicPopup.alert({ 
            title: 'Error',
            template: msg 
          });
        }); 
      });  
    }); 
  }
      

  function reqError(response) {
    $ionicLoading.hide().then(function() {
      ctrl.prop = null;
      var msg = 'Error recuperando los detalles de la propiedad';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        $ionicHistory.goBack();
      })
    });    
  }
  
  $scope.slideOptions = {
    loop: false,
    effect: 'slide',
    pager: false,
    direction: 'horizontal',
    speed: 500
  }
  
  ctrl.latLng = null; 
  ctrl.marker = null;
  ctrl.mapLoaded = false;
  ctrl.updateMapa = function() {
    if (ctrl.latLng == null) {
      ctrl.mapLoaded = false;
      ctrl.latLng = new google.maps.LatLng(ctrl.prop.geo_lat, ctrl.prop.geo_long);
      var mapOptions = {
        center: ctrl.latLng,
        zoom: 15,
        mapTypeId: google.maps.MapTypeId.ROADMAP
      };
      $scope.map = new google.maps.Map(document.getElementById("map"), mapOptions);
      google.maps.event.addListenerOnce($scope.map, 'idle', function(){
        if (ctrl.latLng != null) {
          ctrl.marker = new google.maps.Marker({
              map: $scope.map,
              animation: google.maps.Animation.DROP,
              position: ctrl.latLng
          });      
        }
      });
      google.maps.event.addListenerOnce($scope.map, 'tilesloaded', function(){
        ctrl.mapLoaded = true;
        $scope.$apply();
      });
    } else {
      if (ctrl.marker != null && ctrl.marker != undefined)
        $scope.map.setCenter(ctrl.marker.getPosition());
    }
  };
   
  $scope.$on("$ionicSlides.sliderInitialized", function(event, data){
    $scope.slider = data.slider;
  })  
  
  ctrl.reloadData = function() {
    var key = window.localStorage.getItem("user-key");
    TokkoServices.propiedad({idProp:ctrl.propId, key:key}, reqSuccess, reqError);
  }

  ctrl.nroTelefonico = null;
  ctrl.call = function(contacto) {
    if (contacto != null) {
      var telefonos = contacto._volatile_telefonos; //ContactoUtils.phones(contacto);
      if (telefonos.length == 1) {
        var nroTelefono = telefonos[0].value;
        if (window.plugins != undefined && window.plugins.CallNumber != undefined) {
          window.plugins.CallNumber.callNumber(function() {
              console.log('Call to number '+nroTelefono+' success');
            }, function() {
              console.log('Call to number '+nroTelefono+' error');
            }, nroTelefono, false);
        }              

      } else if (telefonos.length > 0) {
        ctrl.nroTelefonico = null;
        var template = '';
        for (var i=0; i < telefonos.length; i++) {
          template += '<ion-radio ng-model="ctrl.nroTelefonico" ng-value="\''+telefonos[i].value+'\'">\
            <div style="font-size:x-small;">'+telefonos[i].label+'</div><div style="font-size:small;">'+telefonos[i].value+'</div></ion-radio>';  
        }  
      
        var popupCall = $ionicPopup.show({
            template: template,
            title: 'Llamar a '+contacto.name,
            subTitle: 'Elija el número de teléfono',
            scope: $scope,
            buttons: [
              { text: 'Cancelar' },
              {
                text: '<b>Llamar</b>',
                type: 'button-positive',
                onTap: function(e) {
                  if (!ctrl.nroTelefonico) {
                    e.preventDefault();
                  } else {
                    return ctrl.nroTelefonico;
                  }
                }
              }
            ]
          }).then(function(nroTelefono) {
            if (nroTelefono != undefined) {
              if (window.plugins != undefined && window.plugins.CallNumber != undefined) {
                window.plugins.CallNumber.callNumber(function() {
                    console.log('Call to number '+nroTelefono+' success');
                  }, function() {
                    console.log('Call to number '+nroTelefono+' error');
                  }, nroTelefono, false);
              }              
            }
          });

      } else {
        $ionicPopup.alert({
          title: 'Error',
          template: 'El contacto no tiene ningún nro de teléfono cargado'
        });        
      }
    }
  }

  $ionicModal.fromTemplateUrl('templates/image-modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    console.log("modal initialized!");
    $scope.modal = modal;
  });

  ctrl.viewPhoto = function(photoIndex) {
    if (LocalServices.cordovaScreenOrientationOk())
      window.screen.lockOrientation('landscape');
    $ionicSlideBoxDelegate.slide(photoIndex);
    $scope.modal.show();    
  }
  ctrl.closePhoto = function() {
    $scope.modal.hide();
    if (LocalServices.cordovaScreenOrientationOk())
      window.screen.lockOrientation('portrait');
  };
  ctrl.changedPhoto = function(index) {
    $scope.slideIndex = index;
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if ($ionicHistory.backView() == null) {
      $state.go('login');
      $ionicHistory.clearHistory();
    }
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data){
    $ionicLoading.show({
        template: 'Recuperando detalles...'      
    }).then(function() {
        
      ctrl.propId = $stateParams.id;
      if ($stateParams.contacto != null && $stateParams.contacto != undefined)
        ctrl.contacto = ContactoUtils.process(JSON.parse($stateParams.contacto));
      else
        ctrl.contacto = null;
      
      ctrl.reloadData();
        
    });        
  }); 
});