angular.module('starter.services')

.factory('LocalServices', function($resource) {
  var _this = this;

  //development mode = false
  _this.cordovaKeyboardOk = true;
  _this.cordovaScreenOrientationOk = true;
  //--
  
  _this.useDevUser = false;
  _this.rememberUser = true;

  function getCountItemsXPage() {
    return 10;
  }
  
  //--- usuario logueado
  _this.token = null;
  _this.username = null;
  
  function getToken() {
    return _this.token;
  }
  function setToken(value) {
    _this.token = value;
  }
  function setUsername(value) {
    _this.username = value;
  }
  function getUsername() {
    return _this.username;
  }

  _this.cordovaScreenOrientationOkValidation = function() {
    if (window.screen != undefined && window.screen.lockOrientation != undefined) {
      return _this.cordovaScreenOrientationOk;
    } else {
      var msg = "No se puede controlar la orientacion de la pantalla!!";
      // alert(msg);
      console.warn(msg);      
    }
  }
  
  //--- contacto
  _this.actualizarListaContactos = false;
  function actualizarListaContactos(value) {
    if (value != undefined)
      _this.actualizarListaContactos = value;
    return _this.actualizarListaContactos;
  }
  _this.contactoCreado = null;
  function contactoCreado(value) {
    if (value != undefined)
      _this.contactoCreado = value;
    return _this.contactoCreado;
  }
  
  //--- filtro de busqueda
  _this._searchFilterDefault = {
    tipoPropiedades: [],
    barrio: null,
    operaciones: [],
    precioMin: null, //0,
    precioMax: null, //999999999999,
    dormitorios: [],
    ambientes: [],
    supCubiertaMin: null,
    supCubiertaMax: null,
    supTerrenoMin: null,
    supTerrenoMmax: null
  };
  _this._searchFilter = null;
  _this._newSearchFilter = false;
  
  function getSearchFilterDefault() {
    return _this._searchFilterDefault;
  }
  function getSearchFilter() {    
    if (_this._searchFilter == null && 
      window.localStorage.getItem("searchFilter") != undefined && 
      window.localStorage.getItem("searchFilter") != null) {
      _this._searchFilter = JSON.parse(window.localStorage.getItem("searchFilter"));
    }
    return _this._searchFilter;
  }
  function setSearchFilter(value) {
      console.log("VAL "+JSON.stringify(value));
    if (value == null || value == undefined)
      window.localStorage.removeItem("searchFilter");
    else
      window.localStorage.setItem("searchFilter", JSON.stringify(value));
    _this._searchFilter = value;
  }
  function newSearchFilter(value) {
    if (value != undefined)
      _this._newSearchFilter = value;
    return _this._newSearchFilter;
  }
  function getSearchFilterToInvoke(barrioId, tipoPropiedadesAll) {

    if (_this._searchFilter == null && 
      window.localStorage.getItem("searchFilter") != undefined && 
      window.localStorage.getItem("searchFilter") != null) {
      _this._searchFilter = JSON.parse(window.localStorage.getItem("searchFilter"));
    }
    var filter = _this._searchFilter;
    if (filter == null)
      filter = _this._searchFilterDefault;
    
    var _precioMin = filter.precioMin != null?filter.precioMin:0;
    var _precioMax = filter.precioMax != null?filter.precioMax:999999999999;
    var _operaciones = filter.operaciones.slice();
    if (_operaciones == null || _operaciones == undefined || _operaciones.length == 0) {
      _operaciones = [1,2,3];
    } 
    var _tipoPropiedades = filter.tipoPropiedades;
    if (_tipoPropiedades == null || _tipoPropiedades == undefined || _tipoPropiedades.length == 0) {
      _tipoPropiedades = tipoPropiedadesAll!=null&&tipoPropiedadesAll!=undefined?tipoPropiedadesAll:[];
    }
      
    var arrayBarrios = [];
/*    if (barrioId != null && barrioId != undefined) {
      arrayBarrios.push(barrioId);
    }*/
    if (_this._searchFilter.barrioId != null && _this._searchFilter.barrioId != undefined) {
      arrayBarrios.push(_this._searchFilter.barrioId);
    }      
    var result = {
      "current_localization_type": "division",
      "current_localization_id": arrayBarrios,
      "property_types": _tipoPropiedades,
      "operation_types": _operaciones,
      "price_from": _precioMin,
      "price_to": _precioMax      
    };
      


    var filters = [];
    if (filter.dormitorios != null && filter.dormitorios != undefined && filter.dormitorios.length > 0) {
      for (var pos=0; pos < filter.dormitorios.length; pos++) {
        var item = filter.dormitorios[pos];
        var op = '=';
        if (item[0] == '+') {
          op = '>';
        }
        var value = Number(item);
        filters.push(['suite_amount', op, value]);
      }
    }
    if (filter.ambientes != null && filter.ambientes != undefined && filter.ambientes.length > 0) {
      for (var pos=0; pos < filter.ambientes.length; pos++) {
        var item = filter.ambientes[pos];
        var op = '=';
        if (item[0] == '+') {
          op = '>';
        }
        var value = Number(item);
        filters.push(['room_amount', op, value]);
      }
    }
    if (filter.supCubiertaMin != null && filter.supCubiertaMin != undefined) {
      filters.push(['roofed_surface', '>', filter.supCubiertaMin]);
    }
    if (filter.supCubiertaMax != null && filter.supCubiertaMax != undefined) {
      filters.push(['roofed_surface', '<', filter.supCubiertaMax]);
    }
    if (filter.supTerrenoMin != null && filter.supTerrenoMin != undefined) {
      filters.push(['surface', '>', filter.supTerrenoMin]);
    }
    if (filter.supTerrenoMax != null && filter.supTerrenoMax != undefined) {
      filters.push(['surface', '<', filter.supTerrenoMax]);
    }
    if (filters.length > 0)
        result['filters'] = filters;
    return result;
  }
  function getSearchFilterToSave() {
    
         
    if (_this._searchFilter == null && 
      window.localStorage.getItem("searchFilter") != undefined && 
      window.localStorage.getItem("searchFilter") != null) {
      _this._searchFilter = JSON.parse(window.localStorage.getItem("searchFilter"));
    }
    var filter = _this._searchFilter;
    if (filter == null)
      filter = _this._searchFilterDefault;
      
    var loc_type = "division";
    if (filter.barrioId == 0) {
        loc_type = "country";
    }  
      
    var result = {
      "current_localization_type": loc_type,
      "current_localization_id": filter.barrioId,
      "property_types": filter.tipoPropiedades,
      "operation_types": filter.operaciones,
      "price_from": filter.precioMin,
      "price_to": filter.precioMax,

      "currency":null
    };

    var filters = [];
    if (filter.dormitorios != null && filter.dormitorios != undefined && filter.dormitorios.length > 0) {
      for (var pos=0; pos < filter.dormitorios.length; pos++) {
        var item = filter.dormitorios[pos];
        var op = '=';
        if (item[0] == '+') {
          op = '>';
        }
        var value = Number(item);
        filters.push(['suite_amount', op, value]);
      }
    }
    if (filter.ambientes != null && filter.ambientes != undefined && filter.ambientes.length > 0) {
      for (var pos=0; pos < filter.ambientes.length; pos++) {
        var item = filter.ambientes[pos];
        var op = '=';
        if (item[0] == '+') {
          op = '>';
        }
        var value = Number(item);
        filters.push(['room_amount', op, value]);
      }
    }
    if (filter.supCubiertaMin != null && filter.supCubiertaMin != undefined) {
      filters.push(['roofed_surface', '>', filter.supCubiertaMin]);
    }
    if (filter.supCubiertaMax != null && filter.supCubiertaMax != undefined) {
      filters.push(['roofed_surface', '<', filter.supCubiertaMax]);
    }
    if (filter.supTerrenoMin != null && filter.supTerrenoMin != undefined) {
      filters.push(['surface', '>', filter.supTerrenoMin]);
    }
    if (filter.supTerrenoMax != null && filter.supTerrenoMax != undefined) {
      filters.push(['surface', '<', filter.supTerrenoMax]);
    }
    if (filters.length > 0)
        result['filters'] = filters;
    return result;
  }

  _this.contactosListMetadata = null;
  _this.contactosList = null;

  function _contactosListMetadata(setValue) {
    if (setValue != undefined) {
      _this.contactosListMetadata = setValue;
    }
    return _this.contactosListMetadata;
  }
  function _contactosList(setValue) {
    if (setValue != undefined) {
      _this.contactosList = setValue;
    }
    return _this.contactosList;
  }

  _this.cleanInternalData = function() {
      window.localStorage.removeItem("user-name");
      window.localStorage.removeItem("user-key");    
      setUsername(undefined);
      setToken(undefined);
      setSearchFilter(null);    
      _this.actualizarListaContactos = false;
      _this.contactoCreado = null;
      _this.contactosListMetadata = null;
      _this.contactosList = null; 
  }

  return {
    cleanInternalData: _this.cleanInternalData,

    cordovaKeyboardOk: _this.cordovaKeyboardOk,
    cordovaScreenOrientationOk: _this.cordovaScreenOrientationOkValidation,
    useDevUser: _this.useDevUser,
    rememberUser: _this.rememberUser,
    getCountItemsXPage: getCountItemsXPage, 

    getToken: getToken,
    setToken: setToken,
    getUsername: getUsername,
    setUsername: setUsername,  
    
    actualizarListaContactos: actualizarListaContactos,
    contactoCreado: contactoCreado,
    
    getSearchFilterDefault: getSearchFilterDefault,
    getSearchFilter: getSearchFilter,
    setSearchFilter: setSearchFilter,
    newSearchFilter: newSearchFilter,
    getSearchFilterToInvoke: getSearchFilterToInvoke,
    getSearchFilterToSave: getSearchFilterToSave//,

    // contactosListMetadata: _contactosListMetadata,
    // contactosList: _contactosList
  };
});
