angular.module('starter.controllers')

.controller('LoginCtrl', function($scope, $state, $timeout, $ionicLoading, $ionicHistory, $ionicPopup, TokkoServices, LocalServices) {
  if (LocalServices.useDevUser)
    $scope.user = {
      username: "yoel@braintly.com",
      password: "12345678"
    };
  else{
    $scope.user = {
      username: null,
      password: null
    };
  }

  $scope.signIn = function(user) {
    $ionicLoading.show({
        template: 'Autenticando...'      
    }).then(function() {
      TokkoServices.authenticate(user, onAuthenticateSucess, onAuthenticateError);
    });
  };
  
  // $scope.signOut = function() {
  //   window.localStorage.removeItem("user-name");
  //   window.localStorage.removeItem("user-key");
  //   LocalServices.setUsername(undefined);
  //   LocalServices.setToken(undefined);
  //   $state.go('login');    
  // };
  
  // var isAuthenticated = function() {
  //   if (window.localStorage.getItem("user-name") != undefined &&
  //       window.localStorage.getItem("user-key") != undefined) {
  //       LocalServices.setUsername(window.localStorage.getItem("user-name"));
  //       LocalServices.setToken(window.localStorage.getItem("user-key"));
  //     $state.go('tab.dash');
  //   }
  // };
  
  var onAuthenticateSucess = function(value, responseHeaders) {
      $ionicLoading.hide().then(function() {
        if (value != undefined && value.success == true) {
          window.localStorage.setItem("user-name", value.name);
          window.localStorage.setItem("user-key", value.key);
          LocalServices.setUsername(value.name);
          LocalServices.setToken(value.key);
          $state.go('tab.dash');
        } else {
          onAuthenticateError({data:value});
        }        
      });
  }; 
  var onAuthenticateError = function(response) {
    $ionicLoading.hide().then(function() {
      var msg = 'E-Mail o constraseña no válidos';
      // if (response != undefined && response.data != undefined && response.data.reason != undefined)
      //   msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });
    });
  };
  
  if (LocalServices.cordovaScreenOrientationOk()) {
    window.screen.lockOrientation('portrait');
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    $ionicHistory.clearHistory();
    if (LocalServices.rememberUser) {
      if (window.localStorage.getItem("user-name") == undefined ||
          window.localStorage.getItem("user-key") == undefined) {        
        LocalServices.cleanInternalData();
      }
    } else {
      LocalServices.cleanInternalData();
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data){
    if (LocalServices.rememberUser) {
      if (window.localStorage.getItem("user-name") != undefined &&
          window.localStorage.getItem("user-key") != undefined) {        
        LocalServices.setUsername(window.localStorage.getItem("user-name"));
        LocalServices.setToken(window.localStorage.getItem("user-key"));
        $state.go('tab.dash');
      }
    }
  }); 
});