angular.module('starter.controllers')

.controller('MailCtrl', function($scope, $state, $stateParams, $timeout, $ionicLoading, $ionicHistory, $ionicPopup, $ionicPlatform, $rootScope, TokkoServices, LocalServices, ContactoUtils) {
  var ctrl = this;

  ctrl.idContacto = null;
  ctrl.mailContacto = null;
  ctrl.asunto = "";
  ctrl.mensaje = "";
  ctrl.adjuntos = [];

  ctrl.oldSoftBack = null;
  ctrl.hardwareBackHandler = null;

  ctrl.enviarMail = function() {
    if (ctrl.asunto.trim() == "") {
      $ionicPopup.alert({
        title: 'Error',
        template: 'Debe completar el Asunto'
      });
      return;
    }
    if (ctrl.mensaje.trim() == "") {
      $ionicPopup.alert({
        title: 'Error',
        template: 'Debe completar el Mensaje'
      });
      return;
    }

    $ionicLoading.show({
        template: 'Enviando mail...'      
    }).then(function() {
      var listaIds=[];
      for (var i=0; i < ctrl.adjuntos.length; i++) {
        listaIds.push(ctrl.adjuntos[i].id);
      }
      var listMails = ctrl.mailContacto.replace(/,\ /g, ",").split(',');
      var key = window.localStorage.getItem("user-key");
      TokkoServices.enviarMail({key:key, contactId:ctrl.idContacto}, {
        ids: listaIds,
        mails: listMails,
        message: ctrl.mensaje,
        subject: ctrl.asunto,
        is_from_development: false
      }, enviarMailSuccess, enviarMailError);
    });      
  }

  var enviarMailSuccess = function(response) {
    $ionicLoading.hide().then(function() {
      //LocalServices.contactosListMetadata(null);
      //LocalServices.contactosList(null);
      
      $state.go('tab.dash-send-mail-success');
      // $ionicLoading.show({
      //   template: 'Mail enviado exitosamente'      
      // }).then(function() {
      //   $timeout(function() {
      //     $ionicLoading.hide().then(function() {
      //       if ($ionicHistory.backView() != null) {
      //         $ionicHistory.goBack();
      //       } else {
      //         $state.go('tab.dash')
      //       }
      //     });
      //   }, 3000);
      // });
    });    
  }

  var enviarMailError = function(response) {
    $ionicLoading.hide().then(function() {
      var msg = "No se pudo enviar el mail";
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });
    });
  }

  ctrl.quitarAdjunto = function(index, idAdjunto) {
    if (index >= 0 && index < ctrl.adjuntos.length) {
      var itemAdjunto = $('#adjuntosArea');
      if (ctrl.adjuntos.length > 1) {
        itemAdjunto = $('#'+idAdjunto);
      }

      if (itemAdjunto != undefined && itemAdjunto.length > 0) {
        var removeItem = function(event) {
          $("body").off('animationend webkitAnimationEnd', removeItem);
          ctrl.adjuntos.splice(index, 1);          
          $scope.$apply();
        }
        $("body").on('animationend webkitAnimationEnd', removeItem);

        itemAdjunto.addClass('itemMailAdjunto-remove');
      }
      
    }
  }

  ctrl.GoBack = function() {
    if (ctrl.asunto.trim() != ""  || ctrl.mensaje.trim() != "") {
      $ionicPopup.confirm({
        title: 'Envio de propiedades',
        template: 'Descartar mail?'
      }).then(function(res) {
        if(res) {
          $ionicHistory.goBack();
        }
      });
    } else {
      $ionicHistory.goBack();
    }
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if ($ionicHistory.backView() == null) {
      $state.go('login');
      $ionicHistory.clearHistory();
    }
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data){
    ctrl.oldSoftBack = $rootScope.$ionicGoBack;
    $rootScope.$ionicGoBack = function() {
        ctrl.GoBack();
    };        
    ctrl.hardwareBackHandler = $ionicPlatform.registerBackButtonAction(function() {
      ctrl.GoBack();
    }, 100);

    ctrl.idContacto = $stateParams.idContacto;
    ctrl.mailContacto = $stateParams.mailContacto.replace(/,/g, ", ");
    ctrl.adjuntos = JSON.parse($stateParams.adjuntos);
  }); 

  $scope.$on('$destroy', function() {
    if (ctrl.hardwareBackHandler != null) {
      ctrl.hardwareBackHandler();
      ctrl.hardwareBackHandler = null;
    }
    if (ctrl.oldSoftBack != null) {
      $rootScope.$ionicGoBack = ctrl.oldSoftBack;
      ctrl.oldSoftBack = null;
    }
  });  
});