angular.module('starter.controllers')

.controller('NewsCtrl', function($scope, $q, $state, $stateParams, $timeout, $ionicLoading, $ionicPlatform, $ionicHistory, $cordovaKeyboard, $ionicPopup, TokkoServices, LocalServices, NovedadUtils, PropiedadUtils, TipoPropiedadUtils) {
  var ctrl = this;
  
  ctrl.cordovaKeyboardOk = LocalServices.cordovaKeyboardOk;
  ctrl.titulo = 'PROPIEDADES';
  ctrl.message = null;

  ctrl.novedades = null;
  ctrl.barrioObj = null;
  ctrl.barrio = null;
  ctrl.barrioBusqueda = null;
  ctrl.propiedadesMetainfo = null;
  ctrl.propiedades = null;

  ctrl.aplicarBusqueda = false;
  
  var novedadesSuccess = function(value) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.barrioBusqueda = null;
      ctrl.propiedades = null;
      ctrl.novedades = NovedadUtils.processList(value);
      $state.go($state.current, {
        barrio:ctrl.barrio, 
        idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined,
        aplicarBusqueda:ctrl.aplicarBusqueda
      }, {location: 'replace', reload: false, inherit: false, notify: false});
      if (ctrl.novedades.length == 0)
        ctrl.message = "Lista de novedades vacia."
      else
        ctrl.message = null;
      ctrl.titulo = 'PROPIEDADES ('+ctrl.novedades.length+')';
    });
  }
  var novedadesError = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.barrioBusqueda = null;
      ctrl.propiedades = null;
      ctrl.novedades = [];
      var msg = 'Error recuperando novedades';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        ctrl.message = "Error de conexión al recuperar los datos."
      });
      ctrl.titulo = 'PROPIEDADES';
    });
  }
  
  var propiedadesSuccess = function(value) {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide().then(function() {
      LocalServices.newSearchFilter(false);
      ctrl.barrioBusqueda = ctrl.barrio;
      ctrl.novedades = null;
      ctrl.propiedadesMetainfo = PropiedadUtils.metadata(value); 
      var listado = PropiedadUtils.processList(value);
      if (ctrl.propiedadesMetainfo.offset == 0)
        ctrl.propiedades = listado;
      else
        ctrl.propiedades = ctrl.propiedades.concat(listado);
      $state.go($state.current, {
        barrio:ctrl.barrio, 
        idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined,
        aplicarBusqueda:ctrl.aplicarBusqueda
      }, {location: 'replace', reload: false, inherit: false, notify: false});
      if (ctrl.propiedades.length == 0)
        ctrl.message = "Lista de propiedades vacia."
      else
        ctrl.message = null;
      ctrl.titulo = 'PROPIEDADES ('+ctrl.propiedadesMetainfo.total_count+')';
    });
  }
  var propiedadesError = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide().then(function() {
      if (ctrl.propiedadesMetainfo == null || ctrl.propiedadesMetainfo == undefined /*|| ctrl.propiedadesMetainfo.offset == 0*/) {
        ctrl.barrioBusqueda = null;
        ctrl.novedades = null;
        ctrl.propiedadesMetainfo = null;
        ctrl.propiedades = [];        
        ctrl.titulo = 'PROPIEDADES';
      } else {
        ctrl.propiedadesMetainfo.next = null;
        ctrl.titulo = 'PROPIEDADES ('+ctrl.propiedadesMetainfo.total_count+')';
      }
      var msg = 'Error recuperando propiedades';      
      if (response != undefined && response.data != undefined){
        if (response.data.reason != undefined)
          msg = response.data.reason;
        else
          msg = response.data;
      } 
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        ctrl.message = "Error de conexión al recuperar los datos.";
      });
    });
  }
  
  
    ctrl.intelliSugerencias = function(query, isInitializing) {
    if (!isInitializing) {
      if (query != null && query.length >= 3) {
        var key = window.localStorage.getItem("user-key");
        var promise = $q(function(resolve, reject) {
          TokkoServices.intelliBusqueda({key:key, expression:query}, function(response) {
            if (response != undefined && response != null && response['objects'] != undefined && response.objects != null && response.objects.length > 0) {
              for (var pos=0; pos < response.objects.length; pos++) {
             
                var label = response.objects[pos].address;//full_location.split('|');
                /*var label = labels[labels.length-1].trim();
                if (labels.length > 1) {
                  label = label + ', ' + labels[labels.length-2].trim();
                }*/
                response.objects[pos]['label_address'] = label;
                
              }
            }
            resolve(response);
          }, reject);
        });
        return promise;
      } else {
        return [];
      }
    }
  }
  
  ctrl.viewDetailsAddress = function(item) {
     $state.transitionTo('tab.news-detail', {id:item.selectedItems.id});
  }
  
  
  
  ctrl.buscarSugerencias = function(query, isInitializing) {
    if (!isInitializing) {
      if (query != null && query.length >= 3) {
        var promise = $q(function(resolve, reject) {
          TokkoServices.barrioBusqueda({expression:query}, function(response) {
            if (response != undefined && response != null && response['objects'] != undefined && response.objects != null && response.objects.length > 0) {
              for (var pos=0; pos < response.objects.length; pos++) {
                var labels = response.objects[pos].full_location.split('|');
                var label = labels[labels.length-1].trim();
                if (labels.length > 1) {
                  label = label + ', ' + labels[labels.length-2].trim();
                }
                response.objects[pos]['label_location'] = label;
              }
            }
            resolve(response);
          }, reject);
        });
        return promise;                
      } else {
        return [];
      }
    }
  }
  
  ctrl.buscar = function(item) {
      console.log("1AAobj: "+ctrl.barrioObj);
      console.log("2AA: "+ctrl.barrio);
    // console.log('buscar... ('+JSON.stringify(item)+')');
    if (item != undefined) {
      if (item.item != undefined)
        ctrl.barrioObj = item.item;
      else if (item.selectedItems != undefined)
        ctrl.barrioObj = item.selectedItems;
      else
        ctrl.barrioObj = null;
    }
    if (ctrl.cordovaKeyboardOk && $cordovaKeyboard != undefined)
      $cordovaKeyboard.close();
    if (ctrl.barrio == undefined || ctrl.barrio['trim'] == undefined)
      ctrl.barrio = null;
    if (ctrl.barrio != null) {
      ctrl.barrio = ctrl.barrio.trim();
      if (ctrl.barrio == '')
        ctrl.barrio = null;
    }
      
      console.log("1BBBBBobj: "+JSON.stringify(ctrl.barrioObj));
      console.log("2BBBBB: "+ctrl.barrio);
      
      
    ctrl.aplicarBusqueda = ctrl.aplicarBusqueda || LocalServices.newSearchFilter();
     console.log('buscar aplicarBusqueda: '+ctrl.aplicarBusqueda);
    // console.log('buscar barrio: '+ctrl.barrio);
    // console.log('buscar novedades: '+ctrl.novedades);
    if (!ctrl.aplicarBusqueda && ctrl.barrio == null && ctrl.novedades == null) {
      // console.log('recuperando novedades...');
      ctrl.novedades = null;
      $ionicLoading.show({
          template: 'Recuperando novedades...'      
      }).then(function() {
        ctrl.reloadData();
      });            
    } else if (ctrl.aplicarBusqueda || (ctrl.barrio != null && (ctrl.barrioBusqueda != ctrl.barrio || LocalServices.newSearchFilter()))) {
      // console.log('recuperando propiedades...');      
      ctrl.propiedades = null;
      $ionicLoading.show({
          template: 'Recuperando propiedades...'      
      }).then(function() {
        ctrl.reloadData();
      });
    }
  }
  ctrl.cleanBarrio = function() {
    ctrl.barrio = null;
    ctrl.barrioBusqueda = null;
    ctrl.barrioObj = null;
    LocalServices.setSearchFilter(null);
    ctrl.aplicarBusqueda = false;
    ctrl.buscar();
  }

  ctrl.tipoPropiedades = [];
  var tipoPropiedadesSuccess = function(response) {
    $ionicLoading.hide().then(function() {
      ctrl.tipoPropiedades = TipoPropiedadUtils.processListToInvoke(response);
      ctrl.buscar();
    });
  }
  var tipoPropiedadesError = function(response) {
    $ionicLoading.hide().then(function() {
      ctrl.tipoPropiedades = [];      
      var msg = 'Error recuperando los tipos de propiedades';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        ctrl.buscar();
      });
    });
  }
  ctrl.reloadTipoPropiedades = function() {
    var key = window.localStorage.getItem("user-key");
    TokkoServices.tipoPropiedades({key:key}, tipoPropiedadesSuccess, tipoPropiedadesError);
  }  

  ctrl.reloadData = function() {
    // console.log('ctrl.reloadData');
    var key = window.localStorage.getItem("user-key");
    if(ctrl.aplicarBusqueda && ctrl.barrio == null){
        ctrl.barrio = "";
        ctrl.barrioObj = {'id':0};
    }

    if (ctrl.barrio == null) {
      // console.log('Buscando novedades...');  
      TokkoServices.novedades({key:key}, novedadesSuccess, novedadesError);
    } else {
      // console.log('Buscando propiedades...');
      // TokkoServices.propiedades({key:key}, propiedadesSuccess, propiedadesError);
      var searchFilter = LocalServices.getSearchFilterToInvoke(ctrl.barrioObj.id, ctrl.tipoPropiedades);
      // console.log(JSON.stringify(searchFilter));
      TokkoServices.propiedadesBusqueda({
        key:key,
        limit:LocalServices.getCountItemsXPage(),
        offset:0,
        order_by:'price',
        order:'ASC',
        data:JSON.stringify(searchFilter)
      }, propiedadesSuccess, propiedadesError);
    }
  }
  ctrl.hasMoreData = function() {
    var result = false;
    if (ctrl.barrio != null && ctrl.propiedadesMetainfo != null && ctrl.propiedadesMetainfo != undefined && ctrl.propiedadesMetainfo.next != null)
      result = true;
    // console.log('has more data('+result+'): '+JSON.stringify(ctrl.propiedadesMetainfo));
    return result;
  }
  ctrl.loadMoreData = function () {
    // console.log('load more data');
    if (ctrl.barrio != null && ctrl.propiedadesMetainfo != null && ctrl.propiedadesMetainfo != undefined && ctrl.propiedadesMetainfo.next != null) {

      var key = window.localStorage.getItem("user-key");
      var page = ctrl.propiedades.length;
      var searchFilter = LocalServices.getSearchFilterToInvoke(ctrl.barrioObj.id, ctrl.tipoPropiedades);
      // console.log('loading more data: limit='+LocalServices.getCountItemsXPage()+' offset='+page);
      TokkoServices.propiedadesBusqueda({
        key:key,
        limit:LocalServices.getCountItemsXPage(),
        offset:page,
        order_by:'price',
        order:'ASC',
        data:JSON.stringify(searchFilter)
      }, propiedadesSuccess, propiedadesError);
    }
  }
  
  ctrl.viewDetail = function(idProp) {
    // // console.log('pre:'+idProp);
    $state.transitionTo('tab.news-detail', {id:idProp});
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data) {    
    ctrl.barrio = $stateParams.barrio;
    ctrl.barrioObj = null;
    if ($stateParams.idBarrio != undefined) {
      ctrl.barrioObj = { 
        id: $stateParams.idBarrio
      };
    }

    ctrl.aplicarBusqueda = false;
    if ($stateParams.aplicarBusqueda != undefined)
      ctrl.aplicarBusqueda = JSON.parse($stateParams.aplicarBusqueda);
    // console.log('apb: '+ctrl.aplicarBusqueda);
    
    $ionicHistory.clearHistory();
    $ionicLoading.show({
        template: 'Recuperando datos...'      
    }).then(function() {
      ctrl.tipoPropiedades = [];
      ctrl.reloadTipoPropiedades();
    });      
  }); 

});
