angular.module('starter.utils')

.factory('NovedadUtils', function(CurrencyUtils, PropiedadUtils) {
  
  function processNovedad(prop) {
    if (prop != undefined) {

      if (prop.property != undefined) {
        prop['_volatile_item'] = prop.property;
        prop['_volatile_item_type'] = 'property';
      } else if (prop.development != undefined) {
        prop['_volatile_item'] = prop.development;
        prop['_volatile_item_type'] = 'development';
      }
       
      if (prop._volatile_item != undefined) {
        var _volatile_type_with_barrio = '';
        if (prop._volatile_item.type.name != undefined) {
          if (prop._volatile_item.location != undefined) {
            _volatile_type_with_barrio = prop._volatile_item.type.name + ' EN ' + prop._volatile_item.location; 
          } else {
            _volatile_type_with_barrio = prop._volatile_item.type.name
          }
        } else {
          if (prop._volatile_item.location != undefined) {
            _volatile_type_with_barrio = 'EN ' + prop._volatile_item.location; 
          }          
        }
        prop._volatile_item['_volatile_type_with_barrio'] = _volatile_type_with_barrio;
        
        if (prop._volatile_item.operations != undefined && prop._volatile_item.operations.length > 0) {
          if (prop._volatile_item.operations.length == 1) {
            prop._volatile_item['_volatile_operation'] = prop._volatile_item.operations[0].type;
            if (prop._volatile_item.operations[0].prices != undefined && prop._volatile_item.operations[0].prices.length == 1) {
              prop._volatile_item['_volatile_price'] = CurrencyUtils.formatCurrency(prop._volatile_item.operations[0].prices[0].currency) 
                + ' ' + CurrencyUtils.formatAmount(prop._volatile_item.operations[0].prices[0].amount);              
            } else {
              prop._volatile_item['_volatile_price'] = '';
            }
          } else {
            prop._volatile_item['_volatile_operation'] = 'V/ALQ';
            prop._volatile_item['_volatile_price'] = '';  
          }
        } else {
          //Actualmente por lo que veo en los datos las propiedades en construccion (development) no incluyen la propiedad 'operations'. 
          //Es correcto que asuma el mismo comportamiento que cuando el listado de operaciones es mayor a 1 y fije el texto en V/ALQ?
          prop._volatile_item['_volatile_operation'] = 'V/ALQ';
          prop._volatile_item['_volatile_price'] = '';
        }        
        
        if (prop._volatile_item.icon_attrs != undefined) {
          if (prop._volatile_item.icon_attrs['length'] != undefined) {
            if (prop._volatile_item.icon_attrs.length > 0) {
              for (var i=0; i<prop._volatile_item.icon_attrs.length; i++) {
                var newsAttr = PropiedadUtils.getPropNewsAttr(prop._volatile_item.icon_attrs[i]);
                if (newsAttr != undefined) {
                  prop._volatile_item.icon_attrs[i]['_volatile_id'] = i;
                  prop._volatile_item.icon_attrs[i]['_volatile_urlIcon'] = newsAttr.urlIcon;
                  prop._volatile_item.icon_attrs[i]['_volatile_label'] = newsAttr.label;
                  var valor = prop._volatile_item.icon_attrs[i][newsAttr.label];
                  if (valor != undefined && valor != null){
                    valor = valor.trim();
                    if (valor.match("m2$") != null) {
                      var n = parseInt(valor.substring(0, valor.length-2).trim());
                      if (n != undefined && n != null && !isNaN(n)) 
                        valor = n+" m2";
                    }
                  } else {
                    valor = '';
                  }
                  prop._volatile_item.icon_attrs[i]['_volatile_value'] = valor;
                }
              }
            }
          } else {
            //no es un arreglo sino un objeto. necesario porque las construcciones (development) no son un listado
            var newsAttr = PropiedadUtils.getPropNewsAttr(prop._volatile_item.icon_attrs);
            var valor = prop._volatile_item.icon_attrs[newsAttr.label];
            if (valor != undefined && valor != null){
              valor = valor.trim();
              if (valor.match("m2$") != null) {                
                var n = parseInt(valor.substring(0, valor.length-2).trim());
                if (n != undefined && n != null && !isNaN(n))
                  valor = n+" m2";                
              }
            } else {
              valor = '';
            }
            prop._volatile_item['icon_attrs'] = [{
                _volatile_id: 0,
                _volatile_urlIcon: newsAttr.urlIcon,
                _volatile_label: newsAttr.label,
                _volatile_value: valor
            }];
          }
        } else {
          prop._volatile_item['icon_attrs'] = [];
        }
        
        if (prop._volatile_item.type.name != undefined) {
          prop._volatile_item.type['_volatile_name'] = prop._volatile_item.type.name.toUpperCase();
        } else {
          prop._volatile_item.type['_volatile_name'] = '';
        }

        if (prop._volatile_item.status == 4) {
          prop._volatile_item['_volatile_statusLabel'] = 'NO DISPONIBLE';
        } else if (prop._volatile_item.status == 3) {
          prop._volatile_item['_volatile_statusLabel'] = 'RESERVADO';
        } else {
          prop._volatile_item['_volatile_statusLabel'] = 'NUEVO';
        }
      }
    }
    return prop;
  }
  function processNovedades(inList) {
    var outList = [];
    if (inList != undefined && inList.length >0) {
      for (var i=0; i<inList.length; i++) {
        var item = processNovedad(inList[i]);
        outList.push(item);
      }
    }
    return outList;
  }

  return {
    process : processNovedad,
    processList : processNovedades
  };
});