angular.module('starter.utils')

.factory('PropiedadUtils', function(CurrencyUtils, DateUtils) {

  function processItem(item, listStarred) {
    if (item != null && item != undefined) {

      item['_voltatile_address'] = item.address!=null&&item.address!=undefined?item.address.toUpperCase():'';

      if (item.status!=null && item.status!=undefined) {
        item['_volatile_status'] = item.status;
      }


      if (listStarred != undefined && listStarred.length > 0) {
        item['_volatile_is_starred'] = false;
        for (var i=0; i<listStarred.length; i++) {
          if (listStarred[i].id == item.id) {
            item['_volatile_is_starred'] = true;
            break;
          }
        }
      } else {
        item['_volatile_is_starred'] = false;
      }

      var _volatile_type_with_barrio = '';
      if (item.type.name != undefined) {
        if (item.location != undefined && item.location.name != undefined) {
          _volatile_type_with_barrio = item.type.name + ' en ' + item.location.name;
        } else {
          _volatile_type_with_barrio = item.type.name
        }
      } else {
        if (item.location != undefined && item.location.name != undefined) {
          _volatile_type_with_barrio = 'en ' + item.location.name;
        }
      }
      item['_volatile_type_with_barrio'] = _volatile_type_with_barrio;
      //---

      if (item.operations != undefined && item.operations.length > 0) {
        if (item.operations.length == 1) {
          item['_volatile_operation'] = item.operations[0].operation_type;
          if (item.operations[0].prices != undefined && item.operations[0].prices.length == 1) {
            item['_volatile_price'] = CurrencyUtils.formatCurrency(item.operations[0].prices[0].currency)
              + ' ' + CurrencyUtils.formatAmount(item.operations[0].prices[0].price);
          } else {
            item['_volatile_price'] = '';
          }
        } else {
          item['_volatile_operation'] = 'V/ALQ';
          item['_volatile_price'] = '';
        }
      } else {
        //Actualmente por lo que veo en los datos las propiedades en construccion (development) no incluyen la propiedad 'operations'.
        //Es correcto que asuma el mismo comportamiento que cuando el listado de operaciones es mayor a 1 y fije el texto en V/ALQ?
        item['_volatile_operation'] = '';
        item['_volatile_price'] = '';
      }
      //---
      item['_volatile_operations'] = [];
      if (item.operations != undefined && item.operations.length > 0) {
        if (item.operations.length > 0) {
          for (var ip=0; ip < item.operations.length; ip++) {
            var pp = '';
            // console.log('['+ip+'] '+item.operations[ip].operation_type+':'+JSON.stringify(item.operations[ip].prices));
            if (item.operations[ip].prices != undefined && item.operations[ip].prices.length == 1) {
              pp = CurrencyUtils.formatCurrency(item.operations[ip].prices[0].currency) + ' '
              + CurrencyUtils.formatAmount(item.operations[ip].prices[0].price);
            }
            // console.log('['+ip+'] '+item.operations[ip].operation_type+':'+pp);
            item['_volatile_operations'].push({
              '_operation': item.operations[ip].operation_type,
              '_price': pp
            });
          }
        } else {
          item['_volatile_operations'].push({
            '_operation': 'V/ALQ',
            '_price': ''
          });
        }
      }
      //---

      if (item.location != null && item.location != undefined &&
        item.location.short_location != null && item.location.short_location != undefined && item.location.short_location != '') {
        item['_volatile_location'] = item.location.short_location.replace(new RegExp('\\|', 'g'), '>');
      } else {
        item['_volatile_location'] = '';
      }
      //---

      if (item.type != null && item.type != undefined && item.type.name != null && item.type.name != undefined) {
        item['_volatile_type'] = item.type.name;
      } else {
        item['_volatile_type'] = '';
      }
      //---

      if (item.icon_attrs != undefined) {
        if (item.icon_attrs['length'] != undefined) {
          if (item.icon_attrs.length > 0) {
            for (var i=0; i<item.icon_attrs.length; i++) {
              var newsAttr = GetPropNewsAttr(item.icon_attrs[i]);
              if (newsAttr != undefined) {
                item.icon_attrs[i]['_volatile_id'] = i;
                item.icon_attrs[i]['_volatile_urlIcon'] = newsAttr.urlIcon;
                item.icon_attrs[i]['_volatile_label'] = newsAttr.label;
                var valor = item.icon_attrs[i][newsAttr.label];
                if (valor != undefined && valor != null){
                  valor = valor.trim();
                  if (valor.match("m2$") != null) {
                    var n = parseInt(valor.substring(0, valor.length-2).trim());
                    if (n != undefined && n != null && !isNaN(n))
                      valor = n+" m2";
                  }
                } else {
                  valor = '';
                }
                item.icon_attrs[i]['_volatile_value'] = valor;
              }
            }
          }
        } else {
          //no es un arreglo sino un objeto. necesario porque las construcciones (development) no son un listado
          var newsAttr = GetPropNewsAttr(item.icon_attrs);
          var valor = item.icon_attrs[newsAttr.label];
          if (valor != undefined && valor != null){
            valor = valor.trim();
            if (valor.match("m2$") != null) {
              var n = parseInt(valor.substring(0, valor.length-2).trim());
              if (n != undefined && n != null && !isNaN(n))
                valor = n+" m2";
            }
          } else {
            valor = '';
          }
          item['icon_attrs'] = [{
              _volatile_id: 0,
              _volatile_urlIcon: newsAttr.urlIcon,
              _volatile_label: newsAttr.label,
              _volatile_value: valor
          }];
        }
      } else {
        item['icon_attrs'] = [];
      }
      //---

      var imageCover = '';
      if (item.photos != undefined && item.photos.length > 0) {
        imageCover = item.photos[0].image;
      } else {
        item.photos = [{
          image: 'img/no-image.svg'
        }]
      }
      item['_volatile_cover'] = imageCover;
      //---

      if (item['custom_tags'] == undefined || item['custom_tags'] == null)
        item['custom_tags'] = [];
      //---

      var basicAttrs = [];
      var extraAttrs = [];
      if (item['extra_attributes'] != undefined && item['extra_attributes'] != null && item['extra_attributes']['length'] != undefined && item['extra_attributes'].length > 0) {
        for (var i=0; i < item.extra_attributes.length; i++) {
          var ii = item.extra_attributes[i];
          if (ii != undefined && ii != null) {
            if (ii['is_measure'] == undefined || ii.is_measure == true) {
              extraAttrs.push(ii);
            } else {
              basicAttrs.push(ii);
            }
          }
        }
      }
      item['_volatile_basicAttrs'] = basicAttrs;
      item['_volatile_extraAttrs'] = extraAttrs;
      //---

      if (item.surface != null && item.surface_measurement == 'HA') {
        item['_volatile_surface'] = item.surface / 10000;
      } else {
        item['_volatile_surface'] = item.surface;
      }

      if (item.roofed_surface != null) {
        item['_volatile_roofed_surface'] = parseInt(item.roofed_surface);
        if (isNaN(item['_volatile_roofed_surface']))
          item['_volatile_roofed_surface'] = item.roofed_surface;
      } else {
        item['_volatile_roofed_surface'] = '';
      }
      if (item._volatile_surface != null) {
        item['_volatile_surface'] = parseInt(item._volatile_surface);
        if (isNaN(item['_volatile_surface']))
          item['_volatile_surface'] = item._volatile_surface;
      } else {
        item['_volatile_surface'] = '';
      }
      if (item.unroofed_surface != null) {
        item['_volatile_unroofed_surface'] = parseInt(item.unroofed_surface);
        if (isNaN(item['_volatile_unroofed_surface']))
          item['_volatile_unroofed_surface'] = item.unroofed_surface;
      } else {
        item['_volatile_unroofed_surface'] = '';
      }
      if (item.semiroofed_surface != null) {
        item['_volatile_semiroofed_surface'] = parseInt(item.semiroofed_surface);
        if (isNaN(item['_volatile_semiroofed_surface']))
          item['_volatile_semiroofed_surface'] = item.semiroofed_surface;
      } else {
        item['_volatile_semiroofed_surface'] = '';
      }
      if (item.total_surface != null) {
        item['_volatile_total_surface'] = parseInt(item.total_surface);
        if (isNaN(item['_volatile_total_surface']))
          item['_volatile_total_surface'] = item.total_surface;
      } else {
        item['_volatile_total_surface'] = '';
      }
      //---

      var tagsAmbientes = [];
      var tagsServicios = [];
      var tagsAdicionales = [];
      if (item['tags'] != null && item['tags'] != undefined && item.tags['length'] != undefined && item.tags.length > 0) {
        for (var i=0; i <  item.tags.length; i++) {
          var ii = item.tags[i];
          if (ii != undefined && ii != null && ii['type'] != undefined) {
            if (ii.type == 1) {
              tagsServicios.push(ii);
            } else if (ii.type == 2) {
              tagsAmbientes.push(ii);
            } else if (ii.type == 3) {
              tagsAdicionales.push(ii);
            }
          }
        }
      }
      item['_volatile_ambientes_tags'] = tagsAmbientes;
      item['_volatile_servicios_tags'] = tagsServicios;
      item['_volatile_adicionales_tags'] = tagsAdicionales;
      //---

      item['_volatile_infoInterna'] = {};
      if (item['appraisers'] != undefined && item.appraisers['length'] != undefined && item.appraisers.length > 0){
        var appraisers = item.appraisers;
        var tasadores = [];
        for (var pos=0; pos<appraisers.length; pos++) {
          if (appraisers['name'] != undefined) {
            tasadores.push(appraisers.name);
          }
        }
        item._volatile_infoInterna['tasadores'] = tasadores;
      } else {
        item._volatile_infoInterna['tasadores'] = [];
      }
      if (item['producer'] != undefined && item.producer['name'] != undefined) {
        item._volatile_infoInterna['productor'] = item.producer.name;
      } else {
        item._volatile_infoInterna['productor'] = null;
      }
      if (item['branch'] != undefined && item.branch['name'] != undefined) {
        item._volatile_infoInterna['sucursal'] = item.branch.name;
      } else {
        item._volatile_infoInterna['sucursal'] = null;
      }
      if (item['internal_comments'] != undefined) {
        item._volatile_infoInterna['comentarios'] = item.internal_comments;
      } else {
        item._volatile_infoInterna['comentarios'] = null;
      }
      if (item['transaction_requeriments'] != undefined) {
        item._volatile_infoInterna['requisitos'] = item.transaction_requeriments;
      } else {
        item._volatile_infoInterna['requisitos'] = null;
      }
      if (item['created_at'] != undefined) {
        item._volatile_infoInterna['fechaAlta'] = DateUtils.fromServiceToUI_02(item.created_at);
      } else {
        item._volatile_infoInterna['fechaAlta'] = '';
      }
      // console.log(JSON.stringify(item._volatile_infoInterna));
      //---

      // if (item.status == 4) {
      //   item['_volatile_statusLabel'] = 'NO DISPONIBLE';
      // } else if (item.status == 3) {
      //   item['_volatile_statusLabel'] = 'RESERVADO';
      // } else {
      //   item['_volatile_statusLabel'] = 'NUEVO';
      // }
      // //---

      item['_volatile_selected'] = false;
      //---
    }
    return item;
  }

  function processList(listIn, listStarred) {
    var lista = [];
    if (listIn != null && listIn != undefined) {
      if (listIn['length'] != undefined )
        lista = listaIn;
      else if (listIn['objects'] != undefined && listIn['objects']['length'] != undefined) {
        lista = listIn.objects;
      }

      for (var pos=0; pos < lista.length; pos++) {
        lista[pos] = processItem(lista[pos], listStarred);
      }
    }
    return lista;
  }

  function extractMetainfo(value) {
    var result = null;
    if (value != null && value != undefined) {
      result = value.meta;
    }
    return result;
  }

  function GetPropNewsAttr (objAttr) {
    var map = {
      'expenses': 'img/attrs/expenses.svg',
      'construction_status': 'img/attrs/property_condition.svg',
      'room_amount': 'img/attrs/room_amount.svg',
      'suite_amount': 'img/attrs/suite_amount.svg',
      'orientation': 'img/attrs/orientation.svg',
      'disposition': 'img/attrs/orientation.svg',
      'roofed_surface': 'img/attrs/roofed_surface.svg',
      'total_surface': 'img/attrs/total_surface.svg',
      'floors_amount': 'img/attrs/floors_amount.svg',
      'electricity': 'img/attrs/electricity.svg',
      'property_condition': 'img/attrs/property_condition.svg',
      'zonification': 'img/attrs/zonification.svg',
      'surface': 'img/attrs/surface.svg'
    };
    var result = undefined;
    for (var prop in objAttr) {
      if (map[prop] != undefined) {
        result = {};
        result['urlIcon'] = map[prop];
        result['label'] = prop;
        break;
      }
    }
    return result;
  }

  return {
    metadata : extractMetainfo,
    process: processItem,
    processList: processList,
    getPropNewsAttr: GetPropNewsAttr
  };
});
