angular.module('starter.controllers')

.controller('SearchCtrl', function($scope, $q, $state, $stateParams, $timeout, $ionicLoading, $ionicPlatform, $ionicHistory, $ionicPopup, $cordovaKeyboard, TokkoServices, LocalServices, PropiedadUtils, ContactoUtils, TipoPropiedadUtils) {
  var ctrl = this;
  
  ctrl.cordovaKeyboardOk = LocalServices.cordovaKeyboardOk;

  ctrl.idContacto = null;
  ctrl.nombreContactoMayus = null;
  ctrl.nombreContacto = null;
  ctrl.mailContacto = null;
  ctrl.contacto = null;

  ctrl.hasSelectedItems = 0;  
  ctrl.modeSelectOn = false;
  
  ctrl.barrioObj = null;
  ctrl.barrio = null;
  ctrl.barrioBusqueda = null;
  ctrl.propiedades = null;

  ctrl.aplicarBusqueda = false;
  
    $scope.goBackCustom = function() {
    //    console.log("hoh");
     //   console.log($ionicHistory.viewHistory())
        //$ionicViewSwitcher.nextDirection('back');
      $state.go('tab.dash',{"idContacto":ctrl.idContacto});
      //  $ionicHistory.goBack();
      
    }
    
    
  var propiedadesSuccess = function(value) {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide().then(function() {
      LocalServices.newSearchFilter(false);
      ctrl.barrioBusqueda = ctrl.barrio;
      ctrl.propiedadesMetainfo = PropiedadUtils.metadata(value);
      var listado = [];
      if (ctrl.contacto != null && ctrl.contacto.starred != null) 
        listado = PropiedadUtils.processList(value, ctrl.contacto.starred);
      else
        listado = PropiedadUtils.processList(value);
      if (ctrl.propiedadesMetainfo.offset == 0)
        ctrl.propiedades = listado;
      else
        ctrl.propiedades = ctrl.propiedades.concat(listado);
        
      $state.go($state.current, {
        idContacto:ctrl.idContacto, 
        nombreContacto:ctrl.nombreContacto, 
        mailContacto:ctrl.mailContacto, 
        barrio:ctrl.barrio, 
        idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined, 
        contacto:ctrl.contacto!=null?JSON.stringify(ctrl.contacto):undefined,
        aplicarBusqueda:ctrl.aplicarBusqueda
      }, {location: 'replace', reload: false, inherit: false, notify: false});
    });
  }
  var propiedadesError = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide().then(function() {
      if (ctrl.propiedadesMetainfo == null || ctrl.propiedadesMetainfo == undefined /*|| ctrl.propiedadesMetainfo.offset == 0*/) {
        ctrl.barrioBusqueda = null;
        ctrl.propiedadesMetainfo = null;
        ctrl.propiedades = [];
      } else {
        ctrl.propiedadesMetainfo.next = null;
        // console.log('>> si');
      }
      var msg = 'Error recuperando propiedades';
      if (response != undefined && response.data != undefined) {
        if (response.data.reason != undefined)
          msg = response.data.reason;
        else
          msg = response.data;
      }        
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });      
    });
  }

  var saveBusquedaSuccess = function(response) {
    $ionicLoading.hide().then(function() {
      if (response != undefined && response.success == true) {
        $ionicPopup.alert({
          title: 'Busqueda',
          template: "Busqueda guardada exitosamente"
        // }).then(function() {
        //   $state.transitionTo('tab.dash', {idContacto:ctrl.idContacto, page:'Searches'});
        });
      } else {
        saveBusquedaError({data:response});  
      }
    });
  }
  var saveBusquedaError = function(response) {
    $ionicLoading.hide().then(function() {
      var msg = "No se pudo guardar la busqueda";
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      });      
    });
  }
  
  ctrl.toggleSelectMode = function() {
    ctrl.modeSelectOn = !ctrl.modeSelectOn;
    if (!ctrl.modeSelectOn) {
      for (var pos=0; pos<ctrl.propiedades.length; pos++)
        ctrl.propiedades[pos]._volatile_selected = false;
    }
    ctrl.hasSelectedItems = 0;
    // console.log('toggleSelectMode: '+ctrl.modeSelectOn);
  }
  
  ctrl.intelliSugerencias = function(query, isInitializing) {
    if (!isInitializing) {
      if (query != null && query.length >= 3) {
        var key = window.localStorage.getItem("user-key");
        var promise = $q(function(resolve, reject) {
          TokkoServices.intelliBusqueda({key:key, expression:query}, function(response) {
              console.log("hhooo "+response.objects[0].id)
            if (response != undefined && response != null && response['objects'] != undefined && response.objects != null && response.objects.length > 0) {
              for (var pos=0; pos < response.objects.length; pos++) {
             
                var label = response.objects[pos].address;//full_location.split('|');
                /*var label = labels[labels.length-1].trim();
                if (labels.length > 1) {
                  label = label + ', ' + labels[labels.length-2].trim();
                }*/
                response.objects[pos]['label_address'] = label;
                
              }
            }
            resolve(response);
          }, reject);
        });
        return promise;
      } else {
        return [];
      }
    }
  }
  
  ctrl.viewDetailsAddress = function(item) {
      //console.log("ITEM: "+JSON.stringify(item));
      var contacto = JSON.stringify(ctrl.contacto)
      console.log("CONTACTOID: "+ctrl.idContacto);
      console.log("CONTACTOID2: "+ctrl.contact);
      console.log("CONTACTOID3: "+ctrl.nombreContacto);
      console.log("HISTORY "+ JSON.stringify($ionicHistory) );
      $state.transitionTo('tab.dash-searchDetail', {id:item.item.id, contacto:contacto});
  }
  
    ctrl.buscarSugerencias = function(query, isInitializing) {
    if (!isInitializing) {
      if (query != null && query.length >= 3) {
        var promise = $q(function(resolve, reject) {
          TokkoServices.barrioBusqueda({expression:query}, function(response) {
            if (response != undefined && response != null && response['objects'] != undefined && response.objects != null && response.objects.length > 0) {
              for (var pos=0; pos < response.objects.length; pos++) {
                var labels = response.objects[pos].full_location.split('|');
                var label = labels[labels.length-1].trim();
                if (labels.length > 1) {
                  label = label + ', ' + labels[labels.length-2].trim();
                }
                response.objects[pos]['label_location'] = label;
              }
            }
            resolve(response);
          }, reject);
        });
        return promise;                
      } else {
        return [];
      }
    }
  }

  ctrl.buscar = function(item) {
//     console.log('buscar... ('+JSON.stringify(item)+')');
    if (item != undefined) {
      if (item.item != undefined) {
        ctrl.barrioObj = item.item;
      }else if (item.selectedItems != undefined){
        ctrl.barrioObj = item.selectedItems;
          ctrl.barrioId = ctrl.barrioObj.id;
      }else{
        ctrl.barrioObj = null;
      }
    }
    if (ctrl.cordovaKeyboardOk && $cordovaKeyboard != undefined)
      $cordovaKeyboard.close();
    if (ctrl.barrio == undefined || ctrl.barrio['trim'] == undefined)
      ctrl.barrio = null;
    if (ctrl.barrio != null) {
      ctrl.barrio = ctrl.barrio.trim();
      if (ctrl.barrio == '')
        ctrl.barrio = null;
    }


      
    ctrl.aplicarBusqueda = ctrl.aplicarBusqueda || LocalServices.newSearchFilter();

    if (ctrl.aplicarBusqueda || 
      (ctrl.barrio != null && (ctrl.barrioBusqueda != ctrl.barrio || LocalServices.newSearchFilter()))) {      
      ctrl.propiedades = null;
      $ionicLoading.show({
          template: 'Recuperando propiedades...'      
      }).then(function() {
        ctrl.reloadData();
      });
    } else {
      ctrl.propiedades = null;

      $state.go($state.current, {
        idContacto:ctrl.idContacto, 
        nombreContacto:ctrl.nombreContacto, 
        mailContacto:ctrl.mailContacto, 
        barrio:ctrl.barrio, 
        idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined, 
        contacto:ctrl.contacto!=null?JSON.stringify(ctrl.contacto):undefined,
        aplicarBusqueda:ctrl.aplicarBusqueda
      }, {location: 'replace', reload: false, inherit: false, notify: false});

    }
  }
  ctrl.cleanBarrio = function() {
    ctrl.barrioObj = null;
    ctrl.barrio = null;
    ctrl.barrioBusqueda = null;
    LocalServices.setSearchFilter(null);
    // console.log("cleanBarrio");
    ctrl.buscar();
  }
  ctrl.save = function() {
      
    if (!ctrl.modeSelectOn) { // && ctrl.barrioObj != null) {
      
      $ionicLoading.show({
          template: 'Guardando busqueda...'      
      }).then(function() {
        var key = window.localStorage.getItem("user-key");
        //if (ctrl.barrioObj != null) {  
        var filtro = LocalServices.getSearchFilterToSave();
        //}
        TokkoServices.crearBusqueda({key:key, contactId:ctrl.idContacto}, {search: filtro}, saveBusquedaSuccess, saveBusquedaError)
      });
    }
  }
  ctrl.sendMail = function() {
    if (ctrl.modeSelectOn) {
      
      var idContacto = ctrl.idContacto;
      var mailContactoList = [];
      if (ctrl.contacto.email != undefined && ctrl.contacto.email != null && ctrl.contacto.email.trim() != '') 
        mailContactoList.push(ctrl.contacto.email.trim());
      if (ctrl.contacto.other_email != undefined && ctrl.contacto.other_email != null && ctrl.contacto.other_email.trim() != '')
        mailContactoList.push(ctrl.contacto.other_email.trim());        
      if (ctrl.contacto.work_email != undefined && ctrl.contacto.work_email != null && ctrl.contacto.work_email.trim() != '')
        mailContactoList.push(ctrl.contacto.work_email.trim());
      // mailContactoList.push('uno@mail');
      // mailContactoList.push('dos@mail')
      var mailContacto = null;
      if (mailContactoList.length > 0)
        mailContacto = mailContactoList.toString();

      if (mailContacto == null || mailContacto == undefined || mailContacto.trim() == "") {
          $ionicPopup.alert({
            title: 'Error',
            template: 'El contacto no tiene mail cargado'
          });        
      } else {
        var adjuntos = [];
        for (var pos=0; pos < ctrl.propiedades.length; pos++) {
          if (ctrl.propiedades[pos]._volatile_selected) {
            var item = {};
            item['id'] = ctrl.propiedades[pos].id;
            item['type_with_barrio'] = ctrl.propiedades[pos]._volatile_type_with_barrio;
            item['address'] = ctrl.propiedades[pos].address;
            item['operation'] = ctrl.propiedades[pos]._volatile_operation;
            item['price'] = ctrl.propiedades[pos]._volatile_price;
            adjuntos.push(item);
          }
        }

        for (var pos=0; pos<ctrl.propiedades.length; pos++) {
          ctrl.propiedades[pos]._volatile_selected = false;
        }
        ctrl.modeSelectOn = false;      

        $state.transitionTo('tab.dash-mail', {idContacto:idContacto, mailContacto:mailContacto, adjuntos:JSON.stringify(adjuntos)});
      }
    }
  }
  ctrl.favorito = function(id, index) {
      console.log("index "+index)
    if (!ctrl.modeSelectOn && ctrl.propiedades != null && ctrl.propiedades != undefined && index >= 0 && index < ctrl.propiedades.length) {
      // console.log('favorito id:'+id+', index:'+index);
      if (ctrl.propiedades[index]._volatile_is_starred) {
        $ionicLoading.show({
          template: 'Quitando destacado...'
        }).then(function() {
          var key = window.localStorage.getItem("user-key");
          TokkoServices.borrarDestacado({key:key, contactId: ctrl.idContacto, objId: id}, {type:'property'}, function(response) {
            //success
            $ionicLoading.hide().then(function() {              
              if (response != undefined && response.success != undefined && response.success == true) {
                ctrl.propiedades[index]._volatile_is_starred = false;
                
                for (var i=0; i < ctrl.contacto.starred.length; i++) {
                  if (ctrl.propiedades[index].id == ctrl.contacto.starred[i].id) {
                    ctrl.contacto.starred.splice(i, 1);
                    break;
                  }
                }
                $state.go($state.current, {
                  idContacto:ctrl.idContacto, 
                  nombreContacto:ctrl.nombreContacto, 
                  mailContacto:ctrl.mailContacto, 
                  barrio:ctrl.barrio, 
                  idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined, 
                  contacto:ctrl.contacto!=null?JSON.stringify(ctrl.contacto):undefined,
                  aplicarBusqueda:ctrl.aplicarBusqueda
                }, {location: 'replace', reload: false, inherit: false, notify: false});
              } else {
                var msg = 'No se pudo quitar el destacado';
                if (response != undefined && response.reason != undefined)
                  msg = response.reason;
                $ionicPopup.alert({
                  title: 'Error',
                  template: msg
                });      
              }
            });
          }, function (response) {
            //error
            $ionicLoading.hide().then(function() {
              var msg = 'No se pudo quitar el destacado';
              if (response != undefined && response.reason != undefined)
                msg = response.reason;
              $ionicPopup.alert({
                title: 'Error',
                template: msg
              });
            });
          });
        });

      } else {
        $ionicLoading.show({
          template: 'Destacando...'
        }).then(function() {
          var key = window.localStorage.getItem("user-key");
          TokkoServices.crearDestacado({key:key, contactId: ctrl.idContacto}, {id:id, type:'property'}, function(response) {
            //success
              console.log("response "+JSON.stringify(response));
            $ionicLoading.hide().then(function() {
              if (response != undefined && response.success != undefined && response.success == true) {
                ctrl.propiedades[index]._volatile_is_starred = true;
                ctrl.contacto.starred.push({
                  id: ctrl.propiedades[index].id,
                  type: {'object': 'property'}
                });
                  
                $state.go($state.current, {
                  idContacto:ctrl.idContacto, 
                  nombreContacto:ctrl.nombreContacto, 
                  mailContacto:ctrl.mailContacto, barrio:ctrl.barrio, 
                  idBarrio:ctrl.barrioObj!=null?ctrl.barrioObj.id:undefined, 
                  contacto:ctrl.contacto!=null?JSON.stringify(ctrl.contacto):undefined,
                  aplicarBusqueda:ctrl.aplicarBusqueda
                }, {location: 'replace', reload: false, inherit: false, notify: false});
              } else {
                var msg = 'No se pudo destacar la propiedad';
                if (response != undefined && response.reason != undefined)
                  msg = response.reason;
                $ionicPopup.alert({
                  title: 'Error',
                  template: msg
                });      
              }
            });
          }, function (response) {
            //error
            $ionicLoading.hide().then(function() {
              var msg = 'No se pudo destacar la propiedad';
              if (response != undefined && response.reason != undefined)
                msg = response.reason;
              $ionicPopup.alert({
                title: 'Error',
                template: msg
              });
            });
          });
        });
      }
    }
  } 
  ctrl.selectItem = function(id, index) {
    if (ctrl.modeSelectOn && ctrl.propiedades != null && ctrl.propiedades != undefined && index >= 0 && index < ctrl.propiedades.length) {
      ctrl.propiedades[index]._volatile_selected = !ctrl.propiedades[index]._volatile_selected;
      if (ctrl.propiedades[index]._volatile_selected)
        ctrl.hasSelectedItems++;
      else
        ctrl.hasSelectedItems--;
      // console.log('select id:'+id+', index:'+index+' = '+ctrl.propiedades[index]._volatile_selected);
    }
  }

  ctrl.tipoPropiedades = [];
  var tipoPropiedadesSuccess = function(response) {
    $ionicLoading.hide().then(function() {
      ctrl.tipoPropiedades = TipoPropiedadUtils.processListToInvoke(response);
      ctrl.buscar();
    });
  }
  var tipoPropiedadesError = function(response) {
    $ionicLoading.hide().then(function() {
      ctrl.tipoPropiedades = [];      
      var msg = 'Error recuperando los tipos de propiedades';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        ctrl.buscar();
      });
    });
  }
  ctrl.reloadTipoPropiedades = function() {
    var key = window.localStorage.getItem("user-key");
    TokkoServices.tipoPropiedades({key:key}, tipoPropiedadesSuccess, tipoPropiedadesError);
  }  

  ctrl.reloadData = function() {
    var key = window.localStorage.getItem("user-key");
    // console.log('Buscando propiedades...');
    //TokkoServices.propiedades({key:key}, propiedadesSuccess, propiedadesError);
    var barrioId = null;
      
    if (ctrl.barrioObj != null && ctrl.barrioObj != undefined && ctrl.barrioObj.id != null && ctrl.barrioObj.id != undefined) {
      barrioId = ctrl.barrioObj.id;
        console.log("cacacaca: "+ctrl.barrioObj);
        console.log("casablanca: "+barrioId);
    }        
    var searchFilter = LocalServices.getSearchFilterToInvoke(barrioId, ctrl.tipoPropiedades);
    TokkoServices.propiedadesBusqueda({
      key:key,
      limit:LocalServices.getCountItemsXPage(),
      offset:0,
      order_by:'price',
      order:'ASC',
      data:JSON.stringify(searchFilter)
    }, propiedadesSuccess, propiedadesError);
  }
  ctrl.hasMoreData = function() {
    var result = false;
    if (ctrl.propiedadesMetainfo != null && ctrl.propiedadesMetainfo != undefined && ctrl.propiedadesMetainfo.next != null)
      result = true;
    // console.log('has more data('+result+'): '+JSON.stringify(ctrl.propiedadesMetainfo));
    return result;
  }
  ctrl.loadMoreData = function () {
    // console.log('load more data');
    if (ctrl.propiedadesMetainfo != null && ctrl.propiedadesMetainfo != undefined && ctrl.propiedadesMetainfo.next != null) {

      var key = window.localStorage.getItem("user-key");
      var page = ctrl.propiedades.length;
      var barrioId = null;
      if (ctrl.barrioObj != null && ctrl.barrioObj != undefined && ctrl.barrioObj.id != null && ctrl.barrioObj.id != undefined) {
        barrioId = ctrl.barrioObj.id;
      }
      var searchFilter = LocalServices.getSearchFilterToInvoke(barrioId, ctrl.tipoPropiedades);
      // console.log('loading more data: limit='+LocalServices.getCountItemsXPage()+' offset='+page);
      TokkoServices.propiedadesBusqueda({
        key:key,
        limit:LocalServices.getCountItemsXPage(),
        offset:page,
        order_by:'price',
        order:'ASC',
        data:JSON.stringify(searchFilter)
      }, propiedadesSuccess, propiedadesError);
    }
  }
  
  ctrl.viewDetail = function(idProp) {
    var contacto = JSON.stringify(ctrl.contacto);
    $state.transitionTo('tab.dash-searchDetail', {id:idProp, contacto:contacto});
  }

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if ($ionicHistory.backView() == null) {
      $state.go('login');
      $ionicHistory.clearHistory();
    }
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');    
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data) {
    ctrl.idContacto = $stateParams.idContacto;
    ctrl.mailContacto = $stateParams.mailContacto;
    ctrl.nombreContacto = $stateParams.nombreContacto;
    ctrl.nombreContactoMayus = $stateParams.nombreContacto;
    if (ctrl.nombreContactoMayus != undefined && ctrl.nombreContactoMayus != null)
      ctrl.nombreContactoMayus = ctrl.nombreContactoMayus.toUpperCase();
    if ($stateParams.contacto != null && $stateParams.contacto != undefined)
      ctrl.contacto = ContactoUtils.process(JSON.parse($stateParams.contacto));
    else
      ctrl.contacto = null;
    ctrl.barrio = $stateParams.barrio;
    ctrl.barrioObj = null;
    if ($stateParams.idBarrio != undefined) {
      ctrl.barrioObj = { 
        id: $stateParams.idBarrio
      };
    }

    ctrl.aplicarBusqueda = false;
    if ($stateParams.aplicarBusqueda != undefined)
      ctrl.aplicarBusqueda = JSON.parse($stateParams.aplicarBusqueda);

    //ctrl.buscar();
    $ionicLoading.show({
        template: 'Recuperando datos...'      
    }).then(function() {
      ctrl.tipoPropiedades = [];
      ctrl.reloadTipoPropiedades();
    });      
  }); 

});