angular.module('starter.controllers')

.controller('SearchFilterCtrl', function ($scope, $q, $state, $timeout, $ionicLoading, $ionicHistory, $ionicPopup, TokkoServices, LocalServices, TipoPropiedadUtils) {
  var ctrl = this;
  
  ctrl.barrioObj = null;
  ctrl.barrio = null;    
  ctrl.barrioId = null;
  ctrl.tipoPropiedades = [];
  ctrl.operaciones = [
    { id:1, name:'Venta', selected: false },
    { id:2, name:'Alquiler', selected: false },
    { id:3, name:'Alq. Temp.', selected: false }
  ];
  ctrl.precioMin = null;
  ctrl.precioMax = null;
  ctrl.dormitorios = [
    { cantidad:'1', selected: false},
    { cantidad:'2', selected: false},
    { cantidad:'3', selected: false},
    { cantidad:'4', selected: false},
    { cantidad:'+4', selected: false}
  ];
  ctrl.ambientes = [
    { cantidad:'1', selected: false},
    { cantidad:'2', selected: false},
    { cantidad:'3', selected: false},
    { cantidad:'4', selected: false},
    { cantidad:'+4', selected: false}
  ];
  ctrl.supCubiertaMin = null;
  ctrl.supCubiertaMax = null;
  ctrl.supTerrenoMin = null;
  ctrl.supTerrenoMax = null;
  
  var buildFilter = function() {
    var tipoPropiedades = [];
    if (ctrl.tipoPropiedades != null && ctrl.tipoPropiedades != undefined && ctrl.tipoPropiedades.length > 0) {
      for (var i=0; i < ctrl.tipoPropiedades.length; i++) {
        if (ctrl.tipoPropiedades[i].selected)
          tipoPropiedades.push(ctrl.tipoPropiedades[i].id);  
      }      
    }
          
    var operaciones = [];
    if (ctrl.operaciones != null && ctrl.operaciones != undefined && ctrl.operaciones.length > 0) {
      for (var i=0; i < ctrl.operaciones.length; i++) {
        if (ctrl.operaciones[i].selected)
          operaciones.push(ctrl.operaciones[i].id);
      }
    }

    var dormitorios = [];
    if (ctrl.dormitorios != null && ctrl.dormitorios != undefined && ctrl.dormitorios.length > 0) {
      for (var i=0; i < ctrl.dormitorios.length; i++) {
        if (ctrl.dormitorios[i].selected)
          dormitorios.push(ctrl.dormitorios[i].cantidad);
      }
    }
    
    var ambientes = [];
    if (ctrl.ambientes != null && ctrl.ambientes != undefined && ctrl.ambientes.length > 0) {
      for (var i=0; i < ctrl.ambientes.length; i++) {
        if (ctrl.ambientes[i].selected)
          ambientes.push(ctrl.ambientes[i].cantidad);
      }
    }

    if (ctrl.barrioObj != null && ctrl.barrioObj != undefined) {
        ctrl.barrioId = ctrl.barrioObj.id;
        
    }  
   //   console.log("AAA; "+ctrl.barrio+" BBBB: "+ctrl.barrioId);
    return {
      tipoPropiedades: tipoPropiedades, 
      barrio: ctrl.barrio,
      barrioId: ctrl.barrioId,    
      operaciones: operaciones,
      precioMin: ctrl.precioMin, 
      precioMax: ctrl.precioMax,
      dormitorios: dormitorios,
      ambientes: ambientes,
      supCubiertaMin: ctrl.supCubiertaMin,
      supCubiertaMax: ctrl.supCubiertaMax,
      supTerrenoMin: ctrl.supTerrenoMin,
      supTerrenoMax: ctrl.supTerrenoMax 
    };
  }
  
  var updateFilter = function() {
    var newFilter = LocalServices.getSearchFilter();
    if (newFilter == null || newFilter == undefined) {
      newFilter = LocalServices.getSearchFilterDefault()
    }
     console.log('newFilter:'+JSON.stringify(newFilter));
    for (var i=0; i < ctrl.tipoPropiedades.length; i++) {
      var selected = false;
      for (var j=0; j < newFilter.tipoPropiedades.length; j++) {
        if (ctrl.tipoPropiedades[i].id == newFilter.tipoPropiedades[j]) {
          selected = true;
          break;
        }
      }
      ctrl.tipoPropiedades[i].selected = selected;
    }
    
    for (var i=0; i < ctrl.operaciones.length; i++) {
      var selected = false;
      for (var j=0; j < newFilter.operaciones.length; j++) {
        if (ctrl.operaciones[i].id == newFilter.operaciones[j]) {
          selected = true;
          break;
        }
      }
      ctrl.operaciones[i].selected = selected;
    }
    ctrl.barrioId = newFilter.barrioId;  
    ctrl.barrio = newFilter.barrio;
    ctrl.precioMin = newFilter.precioMin;
    ctrl.precioMax = newFilter.precioMax; 

    for (var i=0; i < ctrl.dormitorios.length; i++) {
      var selected = false;
      for (var j=0; j < newFilter.dormitorios.length; j++) {
        if (ctrl.dormitorios[i].cantidad == newFilter.dormitorios[j]) {
          selected = true;
          break;
        }
      }
      ctrl.dormitorios[i].selected = selected;
    }
    
    for (var i=0; i < ctrl.ambientes.length; i++) {
      var selected = false;
      for (var j=0; j < newFilter.ambientes.length; j++) {
        if (ctrl.ambientes[i].cantidad == newFilter.ambientes[j]) {
          selected = true;
          break;
        }
      }
      ctrl.ambientes[i].selected = selected;
    }

    ctrl.supCubiertaMin = newFilter.supCubiertaMin;
    ctrl.supCubiertaMax = newFilter.supCubiertaMax;
    ctrl.supTerrenoMin = newFilter.supTerrenoMin;
    ctrl.supTerrenoMax = newFilter.supTerrenoMax;
  } 
  
  ctrl.toggleOperacion = function(index) {
    if (index >= 0 && index < ctrl.operaciones.length) {
      ctrl.operaciones[index].selected = !ctrl.operaciones[index].selected;
    }
  }
  
  ctrl.toggleTipoPropiedad = function(index) {
    if (index >= 0 && index < ctrl.tipoPropiedades.length) {
      ctrl.tipoPropiedades[index].selected = !ctrl.tipoPropiedades[index].selected;
    }
  }

  ctrl.toggleDormitorio = function(index) {
    if (index >= 0 && index < ctrl.dormitorios.length) {
      for (var i=0; i < ctrl.dormitorios.length; i++) {
        if (i != index) {
          ctrl.dormitorios[i].selected = false;
        } else {
          ctrl.dormitorios[index].selected = !ctrl.dormitorios[index].selected;
        }
      }
    }
  }

  ctrl.toggleAmbiente = function(index) {
    if (index >= 0 && index < ctrl.ambientes.length) {
      for (var i=0; i < ctrl.ambientes.length; i++) {
        if (i != index) {
          ctrl.ambientes[i].selected = false;
        } else {
          ctrl.ambientes[index].selected = !ctrl.ambientes[index].selected;
        }
      }
    }
  }

  ctrl.aplicarFiltro = function() {
    // console.log('actualizando filtro de busqueda');
   
    LocalServices.setSearchFilter(buildFilter());

    LocalServices.newSearchFilter(true);
    if ($ionicHistory.backView() != null) {
      $ionicHistory.goBack();
    } else {
      $state.go('tab.news')      
    }
  };
  
  var tipoPropiedadesSuccess = function(value) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.tipoPropiedades = TipoPropiedadUtils.processList(value);
      updateFilter();
    });
  }
  var tipoPropiedadesError = function(response) {
    $scope.$broadcast('scroll.refreshComplete');
    $ionicLoading.hide().then(function() {
      ctrl.tipoPropiedades = [];
      updateFilter();
      var msg = 'Error recuperando tipos de propiedades';
      if (response != undefined && response.data != undefined && response.data.reason != undefined)
        msg = response.data.reason;
      $ionicPopup.alert({
        title: 'Error',
        template: msg
      }).then(function() {
        $ionicHistory.goBack();
      });
    });
  }
  
  
    ctrl.buscarSugerencias = function(query, isInitializing) {
    if (!isInitializing) {
      if (query != null && query.length >= 3) {
        var promise = $q(function(resolve, reject) {
          TokkoServices.barrioBusqueda({expression:query}, function(response) {
            if (response != undefined && response != null && response['objects'] != undefined && response.objects != null && response.objects.length > 0) {
              for (var pos=0; pos < response.objects.length; pos++) {
                var labels = response.objects[pos].full_location.split('|');
                var label = labels[labels.length-1].trim();
                if (labels.length > 1) {
                  label = label + ', ' + labels[labels.length-2].trim();
                }
                response.objects[pos]['label_location'] = label;
              }
            }
            resolve(response);
          }, reject);
        });
        return promise;                
      } else {
        return [];
      }
    }
  }
/*  ctrl.clickedMethod = function (callback) {
    // print out the selected item
    console.log(callback.item);
  }*/
  
  ctrl.clickedMethod = function(item) {
      console.log("1: "+ctrl.barrioObj);
      console.log("2: "+ctrl.barrio);
    if (item != undefined) {
      if (item.item != undefined) {
        ctrl.barrioObj = item.item;
      }else if (item.selectedItems != undefined) {
        ctrl.barrioObj = item.selectedItems;
        ctrl.barrioId = ctrl.barrioObj.id;
      }else{
        ctrl.barrioObj = null;
      }
    }
    if (ctrl.cordovaKeyboardOk && $cordovaKeyboard != undefined)
      $cordovaKeyboard.close();
    if (ctrl.barrio == undefined || ctrl.barrio['trim'] == undefined)
      ctrl.barrio = null;
    if (ctrl.barrio != null) {
      ctrl.barrio = ctrl.barrio.trim();
      if (ctrl.barrio == '')
        ctrl.barrio = null;
    }

      console.log("1b:ID "+ctrl.barrioObj.id);
      console.log("2b: "+ctrl.barrio);
      console.log('buscar... ('+JSON.stringify(item)+')');
  }
  
  
  ctrl.cancelSelection = function() {
      ctrl.barrio = null;
      ctrl.barrioObj = null;
      ctrl.barrioId = null;
  }
  
  ctrl.reloadData = function() {
    var key = window.localStorage.getItem("user-key");
    TokkoServices.tipoPropiedades({key:key}, tipoPropiedadesSuccess, tipoPropiedadesError);
  }  
  
  $scope.$on("$ionicView.beforeEnter", function(event, data){
    if ($ionicHistory.backView() == null) {
      $state.go('login');
      $ionicHistory.clearHistory();
    }
    
    if (window.localStorage.getItem("user-name") == undefined ||
        window.localStorage.getItem("user-key") == undefined) {
      $state.go('login');
    }
  }); 

  $scope.$on("$ionicView.enter", function(event, data) {
    LocalServices.newSearchFilter(false);
    $ionicLoading.show({
        template: 'Recuperando tipo de propiedades...'      
    }).then(function() {
      ctrl.reloadData();
    });  
  }); 
  
  // $scope.$on("$ionicView.leave", function(event, data){
  //   $ionicHistory.
  // }
});