angular.module('starter.services')

.factory('TokkoServices', function($resource, $http) {
  //login
  var urlLogin = 'http://tokkobroker.com/api/app/user/login/';
  var loginService = $resource(urlLogin, {}, {
      'authenticate': {
          method: 'POST',
          isArray: false,
          headers: {
              'Content-Type': 'application/json'
          }
      }        
  });
  

  //busqueda de barrios
  var urlBarrios = 'http://tokkobroker.com/api/app/location/quicksearch/?format=:format&lang=:lang&order_by=:order_by&order=:order&scope=:scope&type=:type&q=:expression';
  var barriosService = $resource(urlBarrios, {
    format:'json',
    lang:'es_ar',
    order_by:'id',
    order:'asc',
    scope:'minimal',
    type:'1,2,3,4,5',
    expression:'@expression'
  }, {
    'buscar': {
      method: 'GET',
      isArray: false
    }
  });    
    
    
    //intellisearch
  var urlIntelli = 'http://tokkobroker.com/api/app/property/intellisearch/?key=:key&s=:expression';
  var intelliService = $resource(urlIntelli, {
    key:'@key',
    expression:'@expression'
  }, {
    'buscar': {
      method: 'GET',
      isArray: false
    }
  });

  //novedades  
  var urlNovedades = 'http://tokkobroker.com/api/app/user/news/?key=:key';
  // newer_than older_than 
  var novedadesService = $resource(urlNovedades, {key:'@key'}, {
     'novedades' :{
       method: 'GET',
       isArray: true
     }
  });

  //contactos
  var urlContactos = 'http://tokkobroker.com/api/app/contact/?key=:key&limit=:limit&offset=:offset';
  var contactosService = $resource(urlContactos, {key: '@key', limit: '@limit', offset: '@offset'}, {
    'contactos': {
      method: 'GET',
      isArray: false 
    },
    'nuevo': {
      method: 'POST',
      isArray: false,
      headers: {
        'Content-Type': 'application/json'
      }
    }
  });
  var urlContactoById = 'http://tokkobroker.com/api/app/contact/:contactId/?key=:key';
  var contactoByIdService = $resource(urlContactoById, {key: '@key', contactId: '@contactId'}, {
    'contacto': {
      method: 'GET',
      isArray: false 
    }
  });
  var urlContactosBusqueda = 'http://tokkobroker.com/api/app/contact/search/?key=:key&s=:expression';
  var contactosBusquedaService = $resource(urlContactosBusqueda, {key: '@key', expression:'@expression'}, {
    'buscar' : {
      method: 'GET',
      isArray: true
    }
  });
  var urlContactoEstados = 'http://tokkobroker.com/api/app/contact/:contactId/lead_status/?key=:key';
  var contactoEstadosService = $resource(urlContactoEstados, {key: '@key', contactId: '@contactId'}, {
    'cambiar': {
      method: 'POST',
      isArray: false,
      headers: {
        'Content-Type': 'application/json'
      }
    }
  });
  var urlContactoBusquedas = 'http://tokkobroker.com/api/app/contact/:contactId/search/:searchId/?key=:key';  
  var contactoBusquedasService = $resource(urlContactoBusquedas, {key: '@key', contactId: '@contactId', searchId: '@searchId'}, {
    'crear': {
      url: 'http://tokkobroker.com/api/app/contact/:contactId/search/?key=:key',
      method: 'PUT',
      isArray: false
      // headers: {
      //   'Content-Type': 'application/json'
      // }
    },
    'cerrar': {
      method: 'DELETE'
    }
  });
  var urlContactoMail = 'http://tokkobroker.com/api/app/contact/:contactId/email/?key=:key';
  var contactoMailService = $resource(urlContactoMail, {key: '@key', contactId: '@contactId'}, {
    'enviar': {
      method: 'POST',
      isArray: false,
      headers: {
        'Content-Type': 'application/json'
      }
    }
  });
  var urlContactoDestacado = 'http://tokkobroker.com/api/app/contact/:contactId/star/?key=:key';
  var contactoDestacadoService = $resource(urlContactoDestacado, {key: '@key', contactId: '@contactId'}, {
    'destacar': {
      method: 'PUT',
      isArray: false,
      headers: {
        'Content-Type': 'application/json'
      }
    }
  });
  var contactoDestacadoService2 = function(params, data, callbackSuccess, callbackError) {
    var urlContactoDestacado2 = 'http://tokkobroker.com/api/app/contact/'+params.contactId+'/star/'+params.objId+'/?key='+params.key;
    var configContactoDestacado2 = {
      method: 'DELETE',
      url: urlContactoDestacado2,
      data: data,
      headers: { 
        'Content-Type': 'application/json'
      }
    };
    $http(configContactoDestacado2)
      .then(function(response) {
        if (callbackSuccess != undefined)
          callbackSuccess(response.data);
      }, function (response) {
        if (callbackError != undefined)
          callbackError(response.data);
      });
  }
  // var urlContactoDestacado2 = 'http://tokkobroker.com/api/app/contact/:contactId/star/:objId/?key=:key';
  // var contactoDestacadoService2 = $resource(urlContactoDestacado2, {key: '@key', contactId: '@contactId', objId: '@objId'}, {
  //   'noDestacar': {
  //     method: 'DELETE',
  //     isArray: false,
  //     headers: {
  //       'Content-Type': 'application/json'
  //     }
  //   }
  // });
  
  //listado de oportunidades
  var urlOportunidades = 'http://tokkobroker.com/api/app/lead_status/?key=:key';
  //limit=20 offset=0
  var oportunidadesService = $resource(urlOportunidades, {key: '@key'}, {
    'oportunidades': {
      method: 'GET',
      isArray: false
    }
  });
  
  //listado de tipos de propiedades validas para filtrar la busqueda para un usuario
  var urlTipoPropiedadesByUsuario = 'http://tokkobroker.com/api/app/user/property_types/?key=:key';
  var tipoPropiedadesByUsuario = $resource(urlTipoPropiedadesByUsuario, {key: '@key'}, {
    'tipoPropiedades': {
      method: 'GET',
      isArray: true
    }
  });
  
  //propiedades
  var urlPropiedad = 'http://tokkobroker.com/api/app/property/:idProp/?key=:key';
  var propiedadService = $resource(urlPropiedad, {key:'@key', idProp:'@idProp'}, {
    'propiedad': {
      method: 'GET',
      isArray: false
    }
  });
  var urlPropiedades = 'http://tokkobroker.com/api/app/property/?key=:key';
  var propiedadesService = $resource(urlPropiedades, {key:'@key'}, {
    'propiedades': {
      method: 'GET',
      isArray: false
    }
  });
  var urlPropiedadesBusqueda = 'http://tokkobroker.com/api/app/property/search/?key=:key&lang=:lang&format=:format&limit=:limit&offset=:offset&order_by=:order_by&order=:order&data=:data';
  var propiedadesBusquedaService = $resource(urlPropiedadesBusqueda, {
      key: '@key',
      lang: 'es_ar',
      format: 'json',
      limit: '@limit',
      offset: '@offset',
      order_by: '@order_by',
      order: '@order',
      data: '@data'
    }, {
      'busqueda': {
        method: 'GET',
        isArray: false
      }
    });

  return {
    authenticate: loginService.authenticate,
    novedades: novedadesService.novedades,
    contactos: contactosService.contactos,
    contactoById: contactoByIdService.contacto,
    contactosBusqueda: contactosBusquedaService.buscar,
    agregarContacto: contactosService.nuevo,
    oportunidades: oportunidadesService.oportunidades,
    cambiarOportunidad: contactoEstadosService.cambiar,
    tipoPropiedades: tipoPropiedadesByUsuario.tipoPropiedades,
    propiedad: propiedadService.propiedad,
    propiedades: propiedadesService.propiedades,
    propiedadesBusqueda: propiedadesBusquedaService.busqueda,
    crearBusqueda: contactoBusquedasService.crear,
    cerrarBusqueda: contactoBusquedasService.cerrar,
    intelliBusqueda: intelliService.buscar,
    barrioBusqueda: barriosService.buscar,
    crearDestacado: contactoDestacadoService.destacar,
    borrarDestacado: contactoDestacadoService2,
    enviarMail: contactoMailService.enviar
  }
    
});